///////////////////////////////////////////////////////////////////////////////
///
/// @file PrlStringifyConsts.cpp
///
/// DO NOT EDIT THIS FILE !!!
/// it generated automatically from PrlErrorsValues.h and PrlEventsValues.h
///
/// This file is part of Virtuozzo SDK. Virtuozzo SDK is free
/// software; you can redistribute it and/or modify it under the
/// terms of the GNU Lesser General Public License as published by
/// the Free Software Foundation; either version 2.1 of the License,
/// or (at your option) any later version.
///
/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.
///
/// You should have received a copy of the GNU Lesser General Public
/// License along with this library.  If not, see
/// <http://www.gnu.org/licenses/> or write to Free Software Foundation,
/// 51 Franklin Street, Fifth Floor Boston, MA 02110, USA.
///
/// Our contact details: Virtuozzo International GmbH, Vordergasse 59, 8200
/// Schaffhausen, Switzerland.
///
/// Copyright (c) 1999-2017, Parallels International GmbH.
/// Copyright (c) 2017-2019 Virtuozzo International GmbH, All rights reserved.
///
///////////////////////////////////////////////////////////////////////////////

#include "PrlStringifyConsts.h"
#include "Libraries/Logging/Logging.h"
#include "Interfaces/ParallelsTypes.h"

#define CASE_VALUE_TO_STRING( r )     case ((unsigned int) r) : return #r ;

#ifdef __cplusplus
extern "C" {
#endif

const char * PrlResultToString(unsigned int value)
{
    switch ( value )
    {
        CASE_VALUE_TO_STRING(PRL_ERR_SUCCESS);
        CASE_VALUE_TO_STRING(PRL_ERR_UNEXPECTED);
        CASE_VALUE_TO_STRING(PRL_ERR_OUT_OF_MEMORY);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_HANDLE);
        CASE_VALUE_TO_STRING(PRL_ERR_ACCESS_DENIED);
        CASE_VALUE_TO_STRING(PRL_ERR_BUFFER_OVERRUN);
        CASE_VALUE_TO_STRING(PRL_ERR_UNINITIALIZED);
        CASE_VALUE_TO_STRING(PRL_ERR_UNIMPLEMENTED);
        CASE_VALUE_TO_STRING(PRL_ERR_FAILURE);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_DOUBLE_INIT);
        CASE_VALUE_TO_STRING(PRL_ERR_SYMBOL_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_OPERATION_PENDING);
        CASE_VALUE_TO_STRING(PRL_ERR_NO_DATA);
        CASE_VALUE_TO_STRING(PRL_ERR_TIMEOUT);
        CASE_VALUE_TO_STRING(PRL_ERR_OPERATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_PARAM_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_PARAM);
        CASE_VALUE_TO_STRING(PRL_ERR_NO_DISP_CONFIG_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_BAD_DISP_CONFIG_FILE_SPECIFIED);
        CASE_VALUE_TO_STRING(PRL_ERR_OPEN_DISP_CONFIG_READ);
        CASE_VALUE_TO_STRING(PRL_ERR_OPEN_DISP_CONFIG_WRITE);
        CASE_VALUE_TO_STRING(PRL_ERR_PARSE_DISP_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_PARSING_EVENT);
        CASE_VALUE_TO_STRING(PRL_ERR_DISP_CONFIG_ALREADY_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_NO_VM_DIR_CONFIG_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_BAD_VM_DIR_CONFIG_FILE_SPECIFIED);
        CASE_VALUE_TO_STRING(PRL_ERR_OPEN_VM_DIR_CONFIG_READ);
        CASE_VALUE_TO_STRING(PRL_ERR_OPEN_VM_DIR_CONFIG_WRITE);
        CASE_VALUE_TO_STRING(PRL_ERR_PARSE_VM_DIR_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_DIR_CONFIG_ALREADY_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_BAD_VM_CONFIG_FILE_SPECIFIED);
        CASE_VALUE_TO_STRING(PRL_ERR_OPEN_VM_CONFIG_READ);
        CASE_VALUE_TO_STRING(PRL_ERR_OPEN_VM_CONFIG_WRITE);
        CASE_VALUE_TO_STRING(PRL_ERR_READ_XML_CONTENT);
        CASE_VALUE_TO_STRING(PRL_ERR_PARSE_VM_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CONFIG_ALREADY_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_CONFIG_FILE_NOT_SET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_DIR_FILE_NOT_SET);
        CASE_VALUE_TO_STRING(PRL_ERR_DISP_CONFIG_FILE_NOT_SET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_START_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SET_LICENSE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SET_CONFIG_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_POWER_ON_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_POWER_OFF_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_RESET_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_STATUS_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_PROBLEM_REPORT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_CONFIG_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ALREADY_SUSPENDED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_PAUSE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ALREADY_RESUMED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SAVE_STATE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_RESTORE_STATE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_DEV_CONNECT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_DEV_DISCONNECT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_DEV_CHANGE_MEDIA_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_DEVICE_STATE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_USER_OPERATION_NOT_AUTHORISED);
        CASE_VALUE_TO_STRING(PRL_ERR_ACCESS_TOKEN_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_USER_IS_ALREADY_LOGGED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ALREADY_REGISTERED_VM_UUID);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ALREADY_REGISTERED_VM_PATH);
        CASE_VALUE_TO_STRING(PRL_ERR_PREV_SESSION_IS_ACTIVE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_DIRECTORY_NOT_INITIALIZED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISP_CONFIG_WRITE_ERR);
        CASE_VALUE_TO_STRING(PRL_ERR_USER_DIRECTORY_NOT_SET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_PROCESS_IS_NOT_STARTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_OPERATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_PARSE_HOST_HW_INFO);
        CASE_VALUE_TO_STRING(PRL_ERR_PARSE_HARD_DISK_HW_INFO);
        CASE_VALUE_TO_STRING(PRL_ERR_PARSE_FILESYSTEM_INFO);
        CASE_VALUE_TO_STRING(PRL_ERR_PARSE_USER_PROFILE);
        CASE_VALUE_TO_STRING(PRL_ERR_NO_TARGET_PATH_SPECIFIED);
        CASE_VALUE_TO_STRING(PRL_ERR_DIRECTORY_DOES_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_TARGET_PATH_IS_NOT_DIRECTORY);
        CASE_VALUE_TO_STRING(PRL_ERR_TARGET_NAME_ALREADY_OCCUPIED);
        CASE_VALUE_TO_STRING(PRL_ERR_ACCESS_DENIED_TO_DISK_IMAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_ENTRY_DOES_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_ENTRY_ALREADY_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_RENAME_ENTRY);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_REMOVE_ENTRY);
        CASE_VALUE_TO_STRING(PRL_ERR_BAD_PARAMETERS);
        CASE_VALUE_TO_STRING(PRL_ERR_PARSE_PROBLEM_REPORT);
        CASE_VALUE_TO_STRING(PRL_ERR_NO_PROBLEM_REPORT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_OPEN_PROBLEM_REPORT_READ);
        CASE_VALUE_TO_STRING(PRL_ERR_PROBLEM_REPORT_FILE_NOTSET);
        CASE_VALUE_TO_STRING(PRL_ERR_PROBLEM_REPORT_ALREADY_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_PROBLEM_REPORT_WRITE);
        CASE_VALUE_TO_STRING(PRL_ERR_SAVE_VM_CATALOG);
        CASE_VALUE_TO_STRING(PRL_ERR_UNRECOGNIZED_REQUEST);
        CASE_VALUE_TO_STRING(PRL_ERR_TASK_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_HDD_IMAGE_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_HDD_IMAGE_CLONE_TO_SELF);
        CASE_VALUE_TO_STRING(PRL_ERR_FLOPPY_IMAGE_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_SERIAL_PORT_IMAGE_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_PARALLEL_PORT_IMAGE_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CREATE_HDD_IMAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CREATE_FLOPPY_IMAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_ACCES_DENIED_FILE_TO_PARENT_PARENT_DIR);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CREATE_PARALLEL_PORT_IMAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_NOT_ALL_FILES_WAS_DELETED);
        CASE_VALUE_TO_STRING(PRL_ERR_UNABLE_DROP_SUSPENDED_STATE);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_EDIT_SUSPENDED_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_UUID_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_INCONSISTENCY_VM_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_CLONE_OPERATION_CANCELED);
        CASE_VALUE_TO_STRING(PRL_ERR_SEARCH_CONFIG_OPERATION_CANCELED);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_ALOCA_MEM_FILE_COPY);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_READ_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_SMC_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CONFIG_WAS_CHANGED);
        CASE_VALUE_TO_STRING(PRL_ERR_RETURN_CODE_RANG_EEND);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ALREADY_REGISTERED_UNIQUE_PARAMS);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ALREADY_REGISTERED_VM_NAME);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_NAME_IS_EMPTY);
        CASE_VALUE_TO_STRING(PRL_ERR_PARSE_CLIENT_PREFS);
        CASE_VALUE_TO_STRING(PRL_ERR_USER_PROFILE_WAS_CHANGED);
        CASE_VALUE_TO_STRING(PRL_ERR_USER_CANT_CHANGE_ACCESS_PROFILE);
        CASE_VALUE_TO_STRING(PRL_ERR_USER_CANT_CHANGE_READ_ONLY_VALUE);
        CASE_VALUE_TO_STRING(PRL_ERR_PARSE_COMMON_SERVER_PREFS);
        CASE_VALUE_TO_STRING(PRL_ERR_COMMON_SERVER_PREFS_WERE_CHANGED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CREATE_INVALID_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ALREADY_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_STATUS_INVALID_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_GET_MON_STATE_VM_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_GET_MON_STATE_INVALID_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_GET_MON_STATE_VM_NOT_CONFIGURED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_CONFIG_INVALID_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_CONFIG_NOT_CONFIGURED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SET_CONFIG_INVALID_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CONF_CHANGED_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CONF_CHANGED_INVALID_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CONF_CHANGED_NOT_STARTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CONF_CHANGED_UNSUPPORTED_DEV);
        CASE_VALUE_TO_STRING(PRL_ERR_GET_LICENSE_INVALID_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_SET_LICENSE_INVALID_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_SET_LICENSE_INVALID_KEY);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_START_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_START_NOT_CONFIGURED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_STOP_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_RESTART_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_RESTART_NOT_STARTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_PAUSE_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_PAUSE_NOT_STARTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_PAUSE_ALREADY_PAUSED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_SCR_SIZE_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_SCR_UPDATED_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_SCR_UPDATED_NOT_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SET_VISIBLE_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_VIEW_SCR_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_VIEW_SCR_INVALID_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_VIEW_SCR_NOT_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SEND_REL_MOUSE_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SEND_REL_MOUSE_NOT_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SEND_REL_MOUSE_PAUSED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SEND_ABS_MOUSE_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SEND_ABS_MOUSE_NOT_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SEND_ABS_MOUSE_PAUSED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SEND_KEYBOARD_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SEND_KEYBOARD_NOT_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SEND_KEYBOARD_PAUSED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_INDICATORS_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_INDICATORS_INVALID_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_INDICATORS_NOT_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CREATE_HDD_IMG_INVALID_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CREATE_HDD_IMG_INVALID_CREATE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_HDD_IMG_INVALID_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GET_HDD_IMG_NOT_OPEN);
        CASE_VALUE_TO_STRING(PRL_ERR_UPDATE_MEM_VM_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_UNABLE_SEND_REQUEST);
        CASE_VALUE_TO_STRING(PRL_ERR_UPD_TOOLS_VER_VM_NOT_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_UPD_TOOLS_VER_VM_NOT_CONFIGURED);
        CASE_VALUE_TO_STRING(PRL_ERR_GET_RESOLUTION_TOOL_VMNOTCREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_GET_RESOLUTION_TOOL_INVALID_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_HDD_SIZE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_IN_HDD_CONSTRUCTOR);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_UNABLE_TO_OPEN_VIRTUAL_BRIDGE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ASYNC_CD_CONSTRUCTOR);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_UNABLE_OPEN_DISK_IMAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_UNDEFINED_API_CALL);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_UNABLE_SEND_REQUEST);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ALLOC_MEM_DRV_NOT_STARTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ALLOC_VM_MEMORY);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_FREE_VM_MEMORY);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_INTERACT_PRLS_DRIVER);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_UNABLE_ALLOC_MEM);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MAP_VM_MEM0);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_INIT_MONITOR);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_INIT_VCPU);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_UNABLE_GET_GUEST_CPU);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_VALLOC_MON_BODY);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_VALLOC_PE_IMG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOAD_MONITOR);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_UNABLE_ALLOC_MEM_MONITOR);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_UNABLE_CREATE_TIMER);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_HYPERVIZOR_COMM);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_PRLS_DESCTOP_ALLOC_PHYS_MEM);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MONITOR);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_REQUEST_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_BAD_OS_TYPE);
        CASE_VALUE_TO_STRING(PRL_ERR_ALIGN_ON_4);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_MEMORY_SIZE);
        CASE_VALUE_TO_STRING(PRL_ERR_EXCEED_MEMORY_LIMIT);
        CASE_VALUE_TO_STRING(PRL_ERR_HDD_IMAGE_NOT_SPECIFIED);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_HDD_GEOMETRY);
        CASE_VALUE_TO_STRING(PRL_ERR_CDD_IMAGE_NOT_SPECIFIED);
        CASE_VALUE_TO_STRING(PRL_ERR_FDD_IMAGE_NOT_SPECIFIED);
        CASE_VALUE_TO_STRING(PRL_ERR_MAC_ADDRESS_IS_EMPTY);
        CASE_VALUE_TO_STRING(PRL_ERR_MAC_ADDRESS_IN_CORRECT_LENGTH);
        CASE_VALUE_TO_STRING(PRL_ERR_MAC_ADDRESS_WITH_2_ZERO_START);
        CASE_VALUE_TO_STRING(PRL_ERR_MAC_ADDRESS_WITH_ALL_ZEROS);
        CASE_VALUE_TO_STRING(PRL_ERR_MAC_ADDRESS_WITHIN_CORRECT_SYMBOLS);
        CASE_VALUE_TO_STRING(PRL_ERR_COM_OUTPUT_FILE_IS_NOT_SPECIFIED);
        CASE_VALUE_TO_STRING(PRL_ERR_LPT_OUTPUT_FILE_IS_NOT_SPECIFIED);
        CASE_VALUE_TO_STRING(PRL_ERR_COM_OUTPUT_FILE_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_LPT_OUTPUT_FILE_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_QUEST_EXCEED_RECOMMENDED_MEMORY);
        CASE_VALUE_TO_STRING(PRL_QUEST_CDD_IMAGE_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_QUEST_CD_DRIVE_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_QUEST_HDD_SAME_IMAGE);
        CASE_VALUE_TO_STRING(PRL_QUEST_HDD_IMAGE_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_QUEST_FDD_IMAGE_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_QUEST_FDD_DRIVE_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_FLOPPY_DRIVE_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_FIXME);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_HOME_PATH_IS_NOT_EMPTY);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_PARSE_VM_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_UUID_EMPTY);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_EMPTY_NAME_OF_CLONE);
        CASE_VALUE_TO_STRING(PRL_ERR_MAKE_DIRECTORY);
        CASE_VALUE_TO_STRING(PRL_ERR_SERIAL_IMG_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_SAVE_VM_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_SERIAL_IMG_COPY);
        CASE_VALUE_TO_STRING(PRL_ERR_PARALLEL_PORT_IMG_COPY);
        CASE_VALUE_TO_STRING(PRL_ERR_HDD_IMAGE_COPY);
        CASE_VALUE_TO_STRING(PRL_ERR_INSERTING_VM_TO_CATALOGUE);
        CASE_VALUE_TO_STRING(PRL_ERR_ACCESS_TO_VM_DENIED);
        CASE_VALUE_TO_STRING(PRL_ERR_RETRIEVE_VM_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_DOES_NOT_STOPPED);
        CASE_VALUE_TO_STRING(PRL_ERR_CONCURRENT_COMMAND_EXECUTING);
        CASE_VALUE_TO_STRING(PRL_ERR_GET_USER_HOME_DIR);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_PARSE_DISP_EVENT);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_ACCESS_TOKEN_RECEIVED);
        CASE_VALUE_TO_STRING(PRL_ERR_WS_DISP_CONNECTION_CLOSED);
        CASE_VALUE_TO_STRING(PRL_ERR_SHUT_DOWN_NOT_IFICATION_SERVICE);
        CASE_VALUE_TO_STRING(PRL_ERR_SERVER_GOES_DOWN);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CONNECT_TO_DISPATCHER);
        CASE_VALUE_TO_STRING(PRL_ERR_SEND_COMMAND_TOWS_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_NOT_CONNECTED_TO_DISPATCHER);
        CASE_VALUE_TO_STRING(PRL_ERR_ALREADY_CONNECTED_TO_DISPATCHER);
        CASE_VALUE_TO_STRING(PRL_ERR_DELETING_VM_FROM_CATALOGUE);
        CASE_VALUE_TO_STRING(PRL_ERR_COM_DEVICE_ALREADY_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_LPT_DEVICE_ALREADY_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_FLOPPY_IMAGE_ALREADY_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_USER_NO_AUTH_TO_EDIT_SERVER_SETTINGS);
        CASE_VALUE_TO_STRING(PRL_ERR_UNDER_OLD_HYPERVISOR);
        CASE_VALUE_TO_STRING(PRL_ERR_USER_CANT_CHANGE_PROFILE_ACCESS_PART);
        CASE_VALUE_TO_STRING(PRL_ERR_TOO_LOW_HDD_SIZE);
        CASE_VALUE_TO_STRING(PRL_WARN_LAN_NOT_CONNECTED);
        CASE_VALUE_TO_STRING(PRL_WARN_UNABLE_OPEN_DEVICE_NAME);
        CASE_VALUE_TO_STRING(PRL_WARN_UNABLE_OPEN_DEVICE);
        CASE_VALUE_TO_STRING(PRL_WARN_IMAGE_IS_STOLEN);
        CASE_VALUE_TO_STRING(PRL_WARN_TARGET_HOST_DISK_IS_FULL);
        CASE_VALUE_TO_STRING(PRL_WARN_UNKNOWN_HDD_REQUEST_TYPE);
        CASE_VALUE_TO_STRING(PRL_WARN_FAT32_FILE_OVERRUN);
        CASE_VALUE_TO_STRING(PRL_WARN_HDD_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_INTERNAL_OS_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_NETWORK_ROLLBACK_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_COMMON_SERVER_PREFS_BLOCKED_TO_CHANGE);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_INIT_REAL_CPUS_INFO);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_DEVICES_INITIALIZATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_DEVICES_TERMINATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_OPERATION_WAS_CANCELED);
        CASE_VALUE_TO_STRING(PRL_ERR_PARSE_STATISTICS);
        CASE_VALUE_TO_STRING(PRL_ERR_WRONG_CONNECTION_SECURITY_LEVEL);
        CASE_VALUE_TO_STRING(PRL_ERR_REMOTE_DEVICE_NOT_REGISTERED);
        CASE_VALUE_TO_STRING(PRL_ERR_REMOTE_DEVICE_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_REMOTE_DEVICE_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CHANGE_OWNER_OF_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_DELETE_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CONFIG_DOESNT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_INSTALLATION_PROBLEM);
        CASE_VALUE_TO_STRING(PRL_ERR_VMDIR_INVALID_PATH);
        CASE_VALUE_TO_STRING(PRL_ERR_VMDIR_PATH_IS_NOT_ABSOLUTE);
        CASE_VALUE_TO_STRING(PRL_ERR_API_WASNT_INITIALIZED);
        CASE_VALUE_TO_STRING(PRL_ERR_HDD_IMAGE_IS_ALREADY_EXIST);
        CASE_VALUE_TO_STRING(PRL_WARN_TOO_LOW_HDD_SIZE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_APPLY_CONFIG_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_APPLY_CONFIG_NEEDS_REBOOT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CANT_CLONE_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CANT_DELETE_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CANT_UNREG_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_COULDNT_CREATE_AUTHORIZATION_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_COULDNT_SET_PERMISSIONS_TO_AUTHORIZATION_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_OUT_OF_DISK_SPACE);
        CASE_VALUE_TO_STRING(PRL_ERR_NOT_ENOUGH_PERMS_TO_OPEN_AUTHORIZATION_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SPECIFY_GUEST_INSTALL_FILES);
        CASE_VALUE_TO_STRING(PRL_ERR_IO_SEND_QUEUE_IS_FULL);
        CASE_VALUE_TO_STRING(PRL_ERR_IO_STOPPED);
        CASE_VALUE_TO_STRING(PRL_ERR_IO_UNKNOWN_VM_ID);
        CASE_VALUE_TO_STRING(PRL_ERR_IO_CONNECTION_TIMEOUT);
        CASE_VALUE_TO_STRING(PRL_ERR_IO_AUTHENTICATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_FILES_ALREADY_REMOVED);
        CASE_VALUE_TO_STRING(PRL_ERR_CAN_NOT_GET_DISK_FREE_SPACE);
        CASE_VALUE_TO_STRING(PRL_ERR_NOT_ENOUGH_DISK_FREE_SPACE);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CONVERT_VM_CONFIG_DUE_UNDO_DISKS_PRESENT);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CONVERT_VM_CONFIG_DUE_UNDO_SNAPSHOTS_PRESENT);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CONVERT_HDD_IMAGE_FILE);
        CASE_VALUE_TO_STRING(PRL_QUEST_POWER_OFF);
        CASE_VALUE_TO_STRING(PRL_QUEST_RESET);
        CASE_VALUE_TO_STRING(PRL_ERR_USER_NO_AUTH_TO_SAVE_FILES);
        CASE_VALUE_TO_STRING(PRL_ERR_FDD_IMAGE_COPY);
        CASE_VALUE_TO_STRING(PRL_ERR_FDD_IMAGE_CLONE_TO_SELF);
        CASE_VALUE_TO_STRING(PRL_ERR_USER_NO_AUTH_TO_CREATE_VM_IN_DIR);
        CASE_VALUE_TO_STRING(PRL_ERR_ADD_HW_FLOPPY_IMAGE_NOT_SPECIFYED);
        CASE_VALUE_TO_STRING(PRL_ERR_WINDOWS_EXPRESS_INSTALL_USER_NAME_EMPTY);
        CASE_VALUE_TO_STRING(PRL_ERR_ADD_VM_OPERATION_WAS_CANCELED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CANT_CLONE_HDD_MISSING);
        CASE_VALUE_TO_STRING(PRL_ERR_USER_NO_AUTH_TO_EDIT_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_CONFIG_EDIT_COLLISION);
        CASE_VALUE_TO_STRING(PRL_ERR_INCORRECT_PATH);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ABORT);
        CASE_VALUE_TO_STRING(PRL_ERR_SERVER_PREFS_EDIT_COLLISION);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_DIRECTORY_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_MAC_ADDRESS_INCORRECT);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_RECREATE_HDD);
        CASE_VALUE_TO_STRING(PRL_ERR_AUTHENTICATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_LOCAL_AUTHENTICATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_UPDATE_DEVICE_INFO);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_REPLACE_FLOPPY_IMAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_NO_BOOTING_DEVICE_SELECTED);
        CASE_VALUE_TO_STRING(PRL_ERR_INCORRECT_FDD_PATH);
        CASE_VALUE_TO_STRING(PRL_ERR_HVT_NOT_PRESENT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_TO_REGISTER_IS_NOT_SPECIFIED);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CONFIGURE_PHYSICAL_HDD);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CHANGE_FILE_PERMISSIONS);
        CASE_VALUE_TO_STRING(PRL_ERR_IO_DISABLED);
        CASE_VALUE_TO_STRING(PRL_ERR_HVT_DISABLED);
        CASE_VALUE_TO_STRING(PRL_ERR_VTX_ENABLED_ONLY_IN_SMX);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_DISABLE_AFTER_LOST);
        CASE_VALUE_TO_STRING(PRL_ERR_REMOTE_DISPLAY_HOST_NOT_SPECIFIED);
        CASE_VALUE_TO_STRING(PRL_ERR_REMOTE_DISPLAY_WRONG_PORT_NUMBER);
        CASE_VALUE_TO_STRING(PRL_ERR_CONFIG_BEGIN_EDIT_NOT_FOUND_OBJECT_UUID);
        CASE_VALUE_TO_STRING(PRL_ERR_CONFIG_BEGIN_EDIT_NOT_FOUND_USER_UUID);
        CASE_VALUE_TO_STRING(PRL_ERR_HOST_AMD_GUEST_MAC);
        CASE_VALUE_TO_STRING(PRL_ERR_ATTACH_TO_TASK_BAD_SESSION);
        CASE_VALUE_TO_STRING(PRL_ERR_IMPERSONATE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_REVERT_IMPERSONATE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_REBOOT_HOST);
        CASE_VALUE_TO_STRING(PRL_ERR_GET_NET_SERVICE_STATUS_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_X64GUEST_ON_X32HOST);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_OR_DIR_ALREADY_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_READONLY_FILESYSTEM);
        CASE_VALUE_TO_STRING(PRL_ERR_X64GUEST_ON_X64VM_HVT_DISABLED);
        CASE_VALUE_TO_STRING(PRL_ERR_GUEST_MAC_NOT_ENOUGH_MEMORY);
        CASE_VALUE_TO_STRING(PRL_ERR_GUEST_MAC_INVALID_VERSION);
        CASE_VALUE_TO_STRING(PRL_ERR_ACCESS_DENINED_TO_RUN_WIZARD);
        CASE_VALUE_TO_STRING(PRL_ERR_ANOTHER_USER_SESSIONS_PRESENT);
        CASE_VALUE_TO_STRING(PRL_ERR_SOME_VMS_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_SOME_TASKS_PRESENT);
        CASE_VALUE_TO_STRING(PRL_ERR_DISPATCHER_SERVICE_MODE);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_CONFIGURATION);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_APPLY_CHANGES_PENDING);
        CASE_VALUE_TO_STRING(PRL_ERR_HVT_TURNED_OFF_IN_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_TO_START_VM_TEMPLATE);
        CASE_VALUE_TO_STRING(PRL_ERR_NO_MORE_FREE_INTERFACE_SLOTS);
        CASE_VALUE_TO_STRING(PRL_ERR_TOOLS_UNSUPPORTED_GUEST);
        CASE_VALUE_TO_STRING(PRL_ERR_FREE_DISC_SPACE_FOR_CLONE);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_WRITE_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_DISK_SPACE_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CONFIG_INVALID_VM_UUID);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CONFIG_INVALID_SERVER_UUID);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MUST_BE_STOPPED_BEFORE_RENAMING);
        CASE_VALUE_TO_STRING(PRL_ERR_DISP_VM_IS_NOT_STARTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_INVALID_SWAP_REGION);
        CASE_VALUE_TO_STRING(PRL_ERR_CPU_SHUTDOWN);
        CASE_VALUE_TO_STRING(PRL_ERR_CPU_RESTART);
        CASE_VALUE_TO_STRING(PRL_ERR_ACCESS_DENIED_TO_CHANGE_PERMISSIONS);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_GET_FILE_PERMISSIONS);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_REMOVE_INVALID_VM_AS_NON_ADMIN);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MUST_BE_STOPPED_FOR_CHANGE_DEVICES);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CONVERT_OLD_VM_WITH_INSTALLED_TOOLS);
        CASE_VALUE_TO_STRING(PRL_ERR_CANTS_CREATE_DISK_IMAGE_ON_FAT);
        CASE_VALUE_TO_STRING(PRL_ERR_CANTS_CREATE_DISK_IMAGE_ON_FAT32);
        CASE_VALUE_TO_STRING(PRL_ERR_EXCEED_LIMIT_MAX_RUNNING_VMS);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CREATE_HDD_IMAGE_NO_SPACE);
        CASE_VALUE_TO_STRING(PRL_ERR_USER_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ALREADY_CONNECTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GUESTMEM_FAIL);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CHANGE_OWNER_OF_VM_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CHANGE_OWNER_OF_DISK_IMAGE_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_ONLY_ADMIN_CAN_SET_PARAMETER_STARTLOGINMODE_ROOT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_USER_AUTHENTICATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_GUEST_MAC_NOT_MACSERVER_HOST);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_COULDNT_BE_STARTED_UNDER_SPECIFIED_USER);
        CASE_VALUE_TO_STRING(PRL_ERR_UNSUPPORTED_NETWORK_FILE_SYSTEM);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CREATE_SERIAL_PORT_IMAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_IO_NO_CONNECTION);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ALREADY_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOAD_BINARY_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISP_SHUTDOWN_IN_PROCESS);
        CASE_VALUE_TO_STRING(PRL_ERR_DROP_SUSPEND_FOR_HDD_QUEST);
        CASE_VALUE_TO_STRING(PRL_ERR_OBJECT_WAS_REMOVED);
        CASE_VALUE_TO_STRING(PRL_ERR_NO_TARGET_DIR_PATH_SPECIFIED);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_REMOVE_DIR_ENTRY);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_RENAME_DIR_ENTRY);
        CASE_VALUE_TO_STRING(PRL_ERR_ENTRY_DIR_ALREADY_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_ENTRY_DIR_DOES_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_HANDSHAKE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_WRONG_PROTOCOL_VERSION);
        CASE_VALUE_TO_STRING(PRL_ERR_SSL_HANDSHAKE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISP_LOGON_ACTIONS_REACHED_UP_LIMIT);
        CASE_VALUE_TO_STRING(PRL_ERR_DISP_VM_COMMAND_CANT_BE_EXECUTED);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_TO_CHANGE_PERMISSIONS_ON_REMOTE_LOCATION);
        CASE_VALUE_TO_STRING(PRL_ERR_NO_CD_DRIVE_AVAILABLE);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CONFIGURE_PARTITION_HDD);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_IS_NOT_SUSPENDED);
        CASE_VALUE_TO_STRING(PRL_ERR_COMMAND_SUPPORTED_ONLY_AT_SERVER_MODE);
        CASE_VALUE_TO_STRING(PRL_ERR_API_INCOMPATIBLE);
        CASE_VALUE_TO_STRING(PRL_ERR_GUEST_TOOLS_NOT_INSTALLED);
        CASE_VALUE_TO_STRING(PRL_ERR_XML_WRITE_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ANOTHER_TOOLS_IN_USE);
        CASE_VALUE_TO_STRING(PRL_ERR_NEED_KILL_PREV_SETTING);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_DELETE_STATE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SNAPSHOT_CHANGED_VM_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SNAPSHOT_IN_UNDO_DISKS_MODE);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_KEXT_REBOOT_REQUIRED);
        CASE_VALUE_TO_STRING(PRL_ERR_HYP_ALLOC_VMS_MEMORY);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_UPDATE_SNAPSHOT_DATA_FAILED);
        CASE_VALUE_TO_STRING(PRL_WARN_VM_DVD_DISCONNECT_LOCKED_DEV);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_DVD_DISCONNECT_FAILED_LOCKED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_EDIT_UNABLE_SWITCH_ON_UNDO_DISKS_MODE);
        CASE_VALUE_TO_STRING(PRL_ERR_NVRAM_FILE_COPY);
        CASE_VALUE_TO_STRING(PRL_ERR_SNAPSHOTS_COPY);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_RESTART_GUEST_FAILED);
        CASE_VALUE_TO_STRING(PRL_WNG_START_VM_ON_MOUNTED_DISK);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SNAPSHOT_IN_SAFE_MODE);
        CASE_VALUE_TO_STRING(PRL_ERR_FREE_DISK_SPACE_FOR_CREATE_SNAPSHOT);
        CASE_VALUE_TO_STRING(PRL_ERR_FREE_DISK_SPACE_FOR_REVERT_TO_SNAPSHOT);
        CASE_VALUE_TO_STRING(PRL_ERR_CANNOT_PROCESSING_UNDO_DISKS_FOR_INVALID_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_CANNOT_PROCESSING_SAFE_MODE_FOR_INVALID_VM);
        CASE_VALUE_TO_STRING(PRL_WARN_GOING_TO_TAKE_SMART_GUARD_SNAPSHOT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_ALREADY_REGISTERED);
        CASE_VALUE_TO_STRING(PRL_WARN_VM_DVD_DISCONNECTED_BY_GUEST);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_DIRECTORY_FOLDER_DOESNT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_TRY_AGAIN);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_EDIT_UNABLE_SWITCH_OFF_UNDO_DISKS_MODE);
        CASE_VALUE_TO_STRING(PRL_ERR_IO_INVALID_POINTER_ACCESS);
        CASE_VALUE_TO_STRING(PRL_ERR_NOT_ENOUGH_DISK_SPACE_TO_XML_SAVE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CONFIG_CAN_BE_RESTORED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_CONFIG_IS_ALREADY_VALID);
        CASE_VALUE_TO_STRING(PRL_ERR_NOT_ENOUGH_DISK_SPACE_TO_START_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_EDIT_UNABLE_CHANGE_IP_ADDRESS);
        CASE_VALUE_TO_STRING(PRL_WARN_CANT_CONNECT_VOLUME);
        CASE_VALUE_TO_STRING(PRL_ERR_CONFIGURE_GENERIC_PCI_TASK_ALREADY_RUN);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_DEVICE_DOES_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_START_VM_SINCE_NO_VTD_DRIVER);
        CASE_VALUE_TO_STRING(PRL_ERR_FAILURE_ON_VM_DESTROYED);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_START_VM_SINCE_VTD_DEVICE_ALREADY_USED);
        CASE_VALUE_TO_STRING(PRL_ERR_PREPARE_FOR_HIBERNATE_TASK_ALREADY_RUN);
        CASE_VALUE_TO_STRING(PRL_ERR_PREPARE_FOR_HIBERNATE_VM_WRONG_STATE);
        CASE_VALUE_TO_STRING(PRL_ERR_PREPARE_FOR_HIBERNATE_VM_WITHOUT_TOOLS);
        CASE_VALUE_TO_STRING(PRL_ERR_PREPARE_FOR_HIBERNATE_VM_CANNOT_STAND_BY);
        CASE_VALUE_TO_STRING(PRL_ERR_USER_NO_AUTH_TO_CREATE_ROOT_VM_DIR);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_REVERT_VM_SINCE_VTD_DEVICE_ALREADY_USED);
        CASE_VALUE_TO_STRING(PRL_WARN_NOT_SYMMETRIC_CPU);
        CASE_VALUE_TO_STRING(PRL_WARN_DEV_USB_CONNECT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SNAPSHOT_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SNAPSHOTS_CONFIG_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_WARN_DEV_USB_OPEN_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_LOGIN_BY_MISMATCH_CLIENT_MODE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_IS_EXCLUSIVELY_LOCKED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_IS_NOT_LOCKED);
        CASE_VALUE_TO_STRING(PRL_ERR_NOT_LOCK_OWNER_SESSION_TRIES_TO_UNLOCK);
        CASE_VALUE_TO_STRING(PRL_ERR_CANNOT_SAVE_REMOTE_DEVICE_STATE);
        CASE_VALUE_TO_STRING(PRL_ERR_SUSPEND_REJECTED_BY_GUEST);
        CASE_VALUE_TO_STRING(PRL_ERR_PLAYER_CANT_SUSPEND_IN_PAUSE);
        CASE_VALUE_TO_STRING(PRL_WARN_PREPARE_FOR_HIBERNATE_UNABLE_SUSPEND_DO_STOP);
        CASE_VALUE_TO_STRING(PRL_ERR_HVT_NOT_AVAILABLE_WARNING);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_RESIZE_HDD);
        CASE_VALUE_TO_STRING(PRL_ERR_NETWORK_ADAPTER_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_DISP_START_VM_FOR_COMPACT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_REMOTE_DISPLAY_EMPTY_PASSWORD);
        CASE_VALUE_TO_STRING(PRL_ERR_DISP_AUTO_COMPRESS_PERIOD_OUT_OF_RANGE);
        CASE_VALUE_TO_STRING(PRL_ERR_COMPACT_WRONG_VM_STATE);
        CASE_VALUE_TO_STRING(PRL_ERR_NO_ONE_HARD_DISK_TO_COMPRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_TOOL_PROCESS_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_TOOL_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_DISP_CANNOT_COMPACT_VM_HARD_DISK);
        CASE_VALUE_TO_STRING(PRL_ERR_COMPACT_ALREADY_SWITCHED_ON);
        CASE_VALUE_TO_STRING(PRL_WARN_VERBOSE_LOGGING);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_COMPACT_HARD_DISK_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_AUTO_COMPRESS_TASK_ALREADY_RUN);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_HARD_DISK_NOT_COMPACTABLE);
        CASE_VALUE_TO_STRING(PRL_ERR_HARD_DISK_NOT_VIRTUAL_OR_DISABLED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_COMPACT_NOT_SUPPORTED_GUEST_OS);
        CASE_VALUE_TO_STRING(PRL_WARN_CANNOT_MOUNT_BACK_PARTITION);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_PROCESS_IS_NOT_STARTED_BY_WRONG_HOST_SW);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_RESTORE_STATE_FAILED_VM_STOPPED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISP_TIME_MACHINE_IS_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_SMP_NOT_SUPPORTED_HVT_DISABLED);
        CASE_VALUE_TO_STRING(PRL_ERR_SMP_NOT_SUPPORTED_HVT_NOT_PRESENT);
        CASE_VALUE_TO_STRING(PRL_ERR_HVT_DISABLED_WARNING);
        CASE_VALUE_TO_STRING(PRL_ERR_ACCESS_TO_VM_HDD_DENIED);
        CASE_VALUE_TO_STRING(PRL_ERR_ACCESS_TO_CLONE_VM_DEVICE_DENIED);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CONNECT_TO_DISPATCHER_ITERATIVELY);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_RESOLVE_HOSTNAME);
        CASE_VALUE_TO_STRING(PRL_ERR_PARALLEL_PORT_NO_RASTERIZER);
        CASE_VALUE_TO_STRING(PRL_ERR_NOT_ENOUGH_RIGHTS_FOR_LINKED_CLONE);
        CASE_VALUE_TO_STRING(PRL_ERR_COULDNT_TO_CREATE_HDD_LINKED_CLONE);
        CASE_VALUE_TO_STRING(PRL_ERR_MERGE_XML_DOCUMENT_CONFLICT);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_ACTION_REQUESTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_UNPAUSE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_READ_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_WRITE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_OPEN_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_SERVICE_BUSY);
        CASE_VALUE_TO_STRING(PRL_ERR_PROXY_HANDSHAKE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_PROXY_WRONG_PROTOCOL_VERSION);
        CASE_VALUE_TO_STRING(PRL_ERR_PROXY_WRONG_PORT_NUMBER);
        CASE_VALUE_TO_STRING(PRL_ERR_PROXY_PEER_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_DISPLAY_ENCODINGS_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_ONLY_ADMIN_CAN_SET_VERBOSE_LOGGING);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_HDD_DISCONNECT_FAILED_LOCKED);
        CASE_VALUE_TO_STRING(PRL_ERR_START_VM_BY_NOT_DEFINED_USER);
        CASE_VALUE_TO_STRING(PRL_ERR_START_VM_BY_NOT_AUTH_USER);
        CASE_VALUE_TO_STRING(PRL_WARN_LINK_TO_OUTSIDED_HDD_WILL_BE_DROPPED_AFTER_CLONE);
        CASE_VALUE_TO_STRING(PRL_WARN_OUTSIDED_HDD_WILL_BE_ONLY_LINKED_AFTER_CLONE);
        CASE_VALUE_TO_STRING(PRL_ERR_COULD_NOT_START_FIREWALL_TOOL);
        CASE_VALUE_TO_STRING(PRL_ERR_FIREWALL_TOOL_EXECUTED_WITH_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_CANNOT_EDIT_HARDWARE_FOR_PAUSED_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_MEMORY_QUOTA);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_MEMORY_GUARANTEE);
        CASE_VALUE_TO_STRING(PRL_ERR_UNABLE_APPLY_MEMORY_GUARANTEE);
        CASE_VALUE_TO_STRING(PRL_ERR_LOW_MEMORY_LIMIT);
        CASE_VALUE_TO_STRING(PRL_ERR_CANNOT_EDIT_FIREWALL_AT_TRANS_VM_STATE);
        CASE_VALUE_TO_STRING(PRL_ERR_UNABLE_APPLY_TOTAL_LIMIT);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_TOTAL_LIMIT);
        CASE_VALUE_TO_STRING(PRL_ERR_AUDIO_ENCODINGS_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_MSG_START_32BIT_VM_ON_64BIT_HOST);
        CASE_VALUE_TO_STRING(PRL_WARN_VM_SYNC_DEFAULT_PRINTER_DISABLED);
        CASE_VALUE_TO_STRING(PRL_ERR_TIME_MACHINE_EXCLUDED_LIST_OP);
        CASE_VALUE_TO_STRING(PRL_ERR_START_SAFE_MODE_UNSUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_COPY_VM_INFO_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_DISPLAY_FORMAT_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_IOSERVICE_COMPRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_CREATE_FLOPPY_IMAGE_PARAMETERS);
        CASE_VALUE_TO_STRING(PRL_ERR_RUN_VM_ACTION_SCRIPT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_IN_WAKING_UP_STATE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_IN_FROZEN_STATE);
        CASE_VALUE_TO_STRING(PRL_ERR_MEM_EXCEED_PHY_SPACE);
        CASE_VALUE_TO_STRING(PRL_ERR_GET_DISK_FREE_SPACE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISP_VM_IS_NOT_STOPPED);
        CASE_VALUE_TO_STRING(PRL_ERR_MOBILE_ADVANCED_AUTH_REQUIRED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_HYPERVISOR_HVT_ENABLED_ON_HYPERSWITCH);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CHANGE_PROXY_MANAGER_URL);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CHANGE_HOST_ID);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CHANGE_PROXY_MANAGER_URL_BY_NON_PRIVILEGED_USER);
        CASE_VALUE_TO_STRING(PRL_WARN_WINDOWS_UPDATE_WORKING);
        CASE_VALUE_TO_STRING(PRL_ERR_NOT_CONNECTED_TO_PROXY_MANAGER);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LIFETIME_IS_EXPIRED);
        CASE_VALUE_TO_STRING(PRL_ERR_UNABLE_TO_SETUP_HEADLESS_MODE);
        CASE_VALUE_TO_STRING(PRL_ERR_UNABLE_TO_SETUP_HEADLESS_MODE_BY_NON_PRIVILEGED_USER);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_EXPIRATION_TIME_CHECK_INTERVAL_OUT_OF_RANGE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_EXPIRATION_OFFLINE_GRACE_PERIOD_EXPIRED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_EXPIRATION_HOST_DATETIME_SKEWED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_EXPIRATION_VM_IS_IN_OFFLINE_GRACE_PERIOD);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_EXPIRATION_VM_IS_ABOUT_TO_EXPIRE);
        CASE_VALUE_TO_STRING(PRL_ERR_UNABLE_TO_CONTINUE_VM_LIFETIME_IS_EXPIRED);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CHANGE_WEB_PORTAL_DOMAIN);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CHANGE_WEB_PORTAL_DOMAIN_BY_NON_PRIVILEGED_USER);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_EDIT_UNABLE_CONVERT_TO_TEMPLATE);
        CASE_VALUE_TO_STRING(PRL_ERR_DELETE_UNFINISHED_STATE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_EXT_DISK_ALREADY_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_EXT_DISK_CANT_RENAME);
        CASE_VALUE_TO_STRING(PRL_ERR_BRIDGE_NOT_FOUND_FOR_NETWORK_ADAPTER);
        CASE_VALUE_TO_STRING(PRL_ERR_VCMMD_NO_CONNECTION);
        CASE_VALUE_TO_STRING(PRL_WARN_DELETE_NO_CONFIG_UNREGISTER);
        CASE_VALUE_TO_STRING(PRL_WARN_NESTED_VIRT_NOT_ENABLED);
        CASE_VALUE_TO_STRING(PRL_ERR_PPC_INVALID_CREDENTIALS);
        CASE_VALUE_TO_STRING(PRL_ERR_PPC_INVALID_CREDENTIALS_ON_RECONNECT);
        CASE_VALUE_TO_STRING(PRL_ERR_PPC_SERVER_BUSY);
        CASE_VALUE_TO_STRING(PRL_ERR_PPC_UNABLE_TO_CONNECT);
        CASE_VALUE_TO_STRING(PRL_ERR_PAX_HOST_LIMIT_WAS_EXCEEDED);
        CASE_VALUE_TO_STRING(PRL_ERR_CONN_UNABLE_TO_ESTABLISH_TRUSTED_CHANNEL);
        CASE_VALUE_TO_STRING(PRL_ERR_CONN_CLIENT_CERTIFICATE_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_CONN_CLIENT_CERTIFICATE_EXPIRED);
        CASE_VALUE_TO_STRING(PRL_ERR_CONN_CLIENT_CERTIFICATE_REVOKED);
        CASE_VALUE_TO_STRING(PRL_ERR_CONN_SERVER_CERTIFICATE_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_CONN_SERVER_CERTIFICATE_EXPIRED);
        CASE_VALUE_TO_STRING(PRL_ERR_CONN_SERVER_CERTIFICATE_REVOKED);
        CASE_VALUE_TO_STRING(PRL_ERR_PAX_ACCESS_FORBIDDEN);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_FLOPPY_CONNECT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_INCORRECT_CDROM_PATH);
        CASE_VALUE_TO_STRING(PRL_ERR_UNSUPPORTED_DEVICE_TYPE);
        CASE_VALUE_TO_STRING(PRL_WARN_VM_PD3_COMPAT_MODE);
        CASE_VALUE_TO_STRING(PRL_WARN_VM_BOOTCAMP_MODE);
        CASE_VALUE_TO_STRING(PRL_WARN_VM_PD3_COMPAT_NO_MOUSE);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_PARALLELS_DISK);
        CASE_VALUE_TO_STRING(PRL_ERR_IMAGE_NEED_TO_CONVERT);
        CASE_VALUE_TO_STRING(PRL_ERR_HARD_DISK_IMAGE_CORRUPTED);
        CASE_VALUE_TO_STRING(PRL_ERR_CREATE_HARD_DISK_WITH_ZERO_SIZE);
        CASE_VALUE_TO_STRING(PRL_NET_ETHLIST_CREATE_ERROR);
        CASE_VALUE_TO_STRING(PRL_NET_SYSTEM_ERROR);
        CASE_VALUE_TO_STRING(PRL_NET_WINSCM_OPEN_ERROR);
        CASE_VALUE_TO_STRING(PRL_NET_SRV_NOTIFY_ERROR);
        CASE_VALUE_TO_STRING(PRL_NET_ADAPTER_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_NET_ERR_ADAPTER_CONFIG);
        CASE_VALUE_TO_STRING(PRL_NET_ERR_ETH_NO_BINDABLE_ADAPTER);
        CASE_VALUE_TO_STRING(PRL_NET_ERR_PRL_NO_BINDABLE_ADAPTER);
        CASE_VALUE_TO_STRING(PRL_NET_PRLNET_OPEN_FAILED);
        CASE_VALUE_TO_STRING(PRL_NET_BIND_FAILED);
        CASE_VALUE_TO_STRING(PRL_NET_CABLE_DISCONNECTED);
        CASE_VALUE_TO_STRING(PRL_NET_RENAME_FAILED);
        CASE_VALUE_TO_STRING(PRL_NET_INSTALL_TIMEOUT);
        CASE_VALUE_TO_STRING(PRL_NET_INSTALL_FAILED);
        CASE_VALUE_TO_STRING(PRL_NET_UNINSTALL_FAILED);
        CASE_VALUE_TO_STRING(PRL_NET_CONNECTION_SHARING_CONFLICT);
        CASE_VALUE_TO_STRING(PRL_NET_RESTORE_DEFAULTS_PARTITIAL_SUCCESS);
        CASE_VALUE_TO_STRING(PRL_NET_VLAN_UNSUPPORTED_IN_THIS_VERSION);
        CASE_VALUE_TO_STRING(PRL_NET_VMDEVICE_VIRTUAL_NETWORK_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_NET_VMDEVICE_VIRTUAL_NETWORK_NO_ADAPTER);
        CASE_VALUE_TO_STRING(PRL_NET_VMDEVICE_VIRTUAL_NETWORK_CONFIG_ERROR);
        CASE_VALUE_TO_STRING(PRL_NET_VMDEVICE_VIRTUAL_NETWORK_DISABLED);
        CASE_VALUE_TO_STRING(PRL_NET_IPADDRESS_MODIFY_FAILED_WARNING);
        CASE_VALUE_TO_STRING(PRL_NET_PKTFILTER_ERROR);
        CASE_VALUE_TO_STRING(PRL_NET_DUPLICATE_VIRTUAL_NETWORK_ID);
        CASE_VALUE_TO_STRING(PRL_NET_VIRTUAL_NETWORK_ID_NOT_EXISTS);
        CASE_VALUE_TO_STRING(PRL_NET_VIRTUAL_NETWORK_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_NET_ADAPTER_ALREADY_USED);
        CASE_VALUE_TO_STRING(PRL_NET_VIRTUAL_NETWORK_SHARED_EXISTS);
        CASE_VALUE_TO_STRING(PRL_NET_OFFMGMT_ERROR);
        CASE_VALUE_TO_STRING(PRL_NET_VIRTUAL_NETWORK_SHARED_PROHIBITED);
        CASE_VALUE_TO_STRING(PRL_NET_DUPLICATE_IPPRIVATE_NETWORK_NAME);
        CASE_VALUE_TO_STRING(PRL_NET_IPPRIVATE_NETWORK_DOES_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_NET_IPPRIVATE_NETWORK_INVALID_IP);
        CASE_VALUE_TO_STRING(PRL_NET_VALID_FAILURE);
        CASE_VALUE_TO_STRING(PRL_NET_VALID_WRONG_NET_MASK);
        CASE_VALUE_TO_STRING(PRL_NET_VALID_WRONG_HOST_IP_ADDR);
        CASE_VALUE_TO_STRING(PRL_NET_VALID_WRONG_DHCP_IP_ADDR);
        CASE_VALUE_TO_STRING(PRL_NET_VALID_DHCP_RANGE_WRONG_IP_ADDRS);
        CASE_VALUE_TO_STRING(PRL_NET_VALID_MISMATCH_DHCP_SCOPE_MASK);
        CASE_VALUE_TO_STRING(PRL_NET_VALID_DHCP_SCOPE_RANGE_LESS_MIN);
        CASE_VALUE_TO_STRING(PRL_ERR_SOUND_DEVICE_WRITE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_SOUND_OUT_DEVICE_OPEN_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_SOUND_IN_DEVICE_OPEN_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_SOUND_BAD_EMULATION_TYPE);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_SERIAL_PORT_PHYSICAL_CONNECT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_SERIAL_PORT_PIPE_CONNECT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_SERIAL_PORT_FILE_CONNECT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_SERIAL_PORT_REMOTE_CONNECT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_PARALLEL_PORT_PHYSICAL_CONNECT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_PARALLEL_PORT_PRINTER_CONNECT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_PARALLEL_PORT_FILE_CONNECT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_PARALLEL_PORT_REMOTE_CONNECT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_USB_OPEN_MANAGER_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_USB_INSTALL_DRIVER_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_USB_NO_FREE_PORTS);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_USB_HARD_DEVICE_INSERTED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_USB_HARD_DEVICE_INSERTED2);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_USB_BUSY);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_USB_REUSE);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_USB_CHANGEPID);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_USB_NOT_CONFIGURED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_ALREADY_CONNECTED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_ALREADY_DISCONNECTED);
        CASE_VALUE_TO_STRING(PRL_WARN_UNABLE_OPEN_DEVICE_ON_START_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_PRINTER_OVERFLOW);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_MAX_NUMBER_EXCEEDED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_MAX_CD_HDD_EXCEEDED);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_INITIALIZATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_ALREADY_HOOKED_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_HOOK_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_HOOK_NEED_REBOOT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_WAIT_ASR);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_HOOK_AFTER_INSTALL_NEED_REBOOT);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_HOOK_AFTER_REVERT_NEED_REBOOT);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_HOOK_INSTALLATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_HOOK_REVERT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_HOOK_INVALID_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_HOOK_DEVICE_CURRENTLY_IN_USE);
        CASE_VALUE_TO_STRING(PRL_ERR_MEMORY_ALLOC_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DEV_MAX_CD_EXCEEDED_WITH_DISABLED_CLIENT_SCSII);
        CASE_VALUE_TO_STRING(PRL_WNG_NO_OPERATION_SYSTEM_INSTALLED);
        CASE_VALUE_TO_STRING(PRL_ERR_WIN_AERO_DISABLED);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_DEVICE_TROUBLESHOOT);
        CASE_VALUE_TO_STRING(PRL_ERR_INVALID_OS_TYPE);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_HOOK_UPDATE_SCRIPT_EXECUTE);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_NOT_VALID);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_EXPIRED);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_WRONG_VERSION);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_WRONG_PRODUCT);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_WRONG_PLATFORM);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_WRONG_LANGUAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_WRONG_DISTRIBUTOR);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_AUTH_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_WRONG_ADVANCED_FIELD);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_UPGRADE_NO_PERMANENT_LICENSE);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_FILE_WRITE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_BETA_KEY_RELEASE_PRODUCT);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_TOO_MANY_VCPUS);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RELEASE_KEY_BETA_PRODUCT);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_NOT_STARTED);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_BLACKLISTED);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_TOO_MANY_MEMORY);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_VM_HAS_VTD_DEVICES);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_TIMEOUT);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_CANCEL);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_PROXY_AUTH);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_PROXY);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_NETWORK);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_NOTSUP);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_WRONG);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_NODATA);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_ERR_KA);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_LOCK);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_EACCES);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_NOENT);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_NOINIT);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_IO);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_INVAL);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_NOMEM);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_FATAL);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_INVALID_HWID);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_ACTIVATION_KEY);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_VMS_LIMIT_EXCEEDED);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_UNSUPPORTED_APP_MODE);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_TASK_ALREADY_RUN);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_GUEST_OS);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_RUNNING_VMS_LIMIT);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_CREATE_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_REGISTER_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_REGISTER_3RD_PARTY_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_CLONE_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_CONVERT_TO_TEMPLATE);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_CONVERT_FROM_TEMPLATE);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_SUSPEND_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_PAUSE_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_SNAPSHOT_CREATE);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_SNAPSHOT_SWITCH);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_SNAPSHOT_DELETE);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_SNAPSHOT_SHOW_TREE);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_UNDODISK_FEATURE);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_SAFEMODE_FEATURE);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_SMARTGUARD_FEATURE);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_GRACED);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_CPU_COUNT);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_RESTRICTED_TO_RUNNING_VMS_LIMIT_PER_USER);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_BLACKLISTED_TO_VM_OPERATION);
        CASE_VALUE_TO_STRING(PRL_ERR_VOLUME_LICENSE_EXCEEDED_LIMIT);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_KA_LICENSE_IS_UP_TO_DATE);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_KA_LICENSE_IS_NOT_PROLONGATED_YET);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_KA_LICENSE_EXPIRED);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_KA_ACTIVATION_LIMIT_REACHED);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_KA_HWID_DOES_NOT_MATCH);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_KA_LICENSE_IS_TERMINATED);
        CASE_VALUE_TO_STRING(PRL_WARN_LICENSE_RESTRICTED_RKU);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_UNSUPPORTED_LICENSE_TYPE_TO_DEACTIVATION);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_DEFERRED_LICENSE_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_VZLICENSE_UNSUPPORTED_UPDATE_OP);
        CASE_VALUE_TO_STRING(PRL_ERR_LICENSE_IS_NOT_VOLUME);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATION_WRONG_CONFIRMATION_FORMAT);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATION_WRONG_CONFIRMATION_MESSAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATION_WRONG_CONFIRMATION_SIGNATURE);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATE_WRONG_TYPE_OF_ACTIVE_LICENSE);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATE_NO_INSTALLED_LICENSE);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATE_TRIAL_LICENSE);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATION_SERVER_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATION_SERVER_ACTIVATION_ID_IS_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATION_SERVER_KEY_IS_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATION_SERVER_KEY_IS_BLACKLISTED);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATION_SERVER_HWIDS_AMOUNT_REACHED);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATION_WRONG_SERVER_RESPONSE);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATION_UNABLE_TO_SEND_REQUEST);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATION_HTTP_REQUEST_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_UNABLE_TO_SEND_REQUEST);
        CASE_VALUE_TO_STRING(PRL_ERR_HTTP_REQUEST_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATION_UPDATE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATION_OFFLINE_PERIOD_EXPIRED);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTIVATION_COMMON_SERVER_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DEACTIVATE_WRONG_TYPE_OF_ACTIVE_LICENSE);
        CASE_VALUE_TO_STRING(PRL_ERR_DEACTIVATE_NO_INSTALLED_LICENSE);
        CASE_VALUE_TO_STRING(PRL_ERR_DEACTIVATE_TRIAL_LICENSE);
        CASE_VALUE_TO_STRING(PRL_ERR_DEACTIVATION_SERVER_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DEACTIVATION_SERVER_ACTIVATION_ID_IS_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_DEACTIVATION_SERVER_KEY_IS_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_DEACTIVATION_SERVER_KEY_IS_BLACKLISTED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEACTIVATION_WRONG_SERVER_RESPONSE);
        CASE_VALUE_TO_STRING(PRL_ERR_DEACTIVATION_UNABLE_TO_SEND_REQUEST);
        CASE_VALUE_TO_STRING(PRL_ERR_DEACTIVATION_HTTP_REQUEST_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DEACTIVATION_COMMON_SERVER_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DEACTIVATION_OLD_HWID_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_LIC_REGISTRATION_COMMON_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_VTD_DEVICE_NOT_MAPPED);
        CASE_VALUE_TO_STRING(PRL_QUESTION_CONVERT_3RD_PARTY_CANNOT_MIGRATE);
        CASE_VALUE_TO_STRING(PRL_QUESTION_CONVERT_VM_SPECIFY_DISTRO_PATH);
        CASE_VALUE_TO_STRING(PRL_QUESTION_ASK_ENCRYPTED_VM_PASSWORD);
        CASE_VALUE_TO_STRING(PRL_QUESTION_CONVERT_VM_CANT_DETECT_OS);
        CASE_VALUE_TO_STRING(PRL_WARN_VM_DISCONNECT_SATA_HDD);
        CASE_VALUE_TO_STRING(PRL_QUESTION_FINALIZE_VM_PROCESS);
        CASE_VALUE_TO_STRING(PRL_QUESTION_CONVERT_GUEST_OS_IS_HIBERNATED);
        CASE_VALUE_TO_STRING(PRL_QUESTION_SETUP_YANDEX_SEARCH);
        CASE_VALUE_TO_STRING(PRL_ERR_UPD_UPDATER_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_UPD_UPDATES);
        CASE_VALUE_TO_STRING(PRL_ERR_CREATE_PRIVELEGED_PROCESS);
        CASE_VALUE_TO_STRING(PRL_ERR_VA_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_UNEXPECTED_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_NO_DISKS);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_PROCESS_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_STOPPING_STATE);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_ROLLBACK_IN_PROGRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_ROLLBACK_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_INVALID_PARAMETERS);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_ERROR_CREATE_IMAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_ERROR_RENAMING_IMAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_CANT_OPEN_IMAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_CANT_OPEN_FOR_WRITE);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_CANT_OPEN_LOCKED);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_CANT_SAVE_LOCKED);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_INT_CORRUPTED);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_NO_STATE);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_ALREADY_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_NOT_OPENED);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_NOT_PERMITTED);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_FULL_DELETE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_MERGE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_MERGE_NO_SPACE);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_MEMORY_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_INVALID_IMAGE_TYPE);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_DELETE_NONCLOSED);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_CANT_LOAD_SPECIFIED_CFG);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_GETFREESPACE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_STATFS_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_STATE_NOT_RELEASED);
        CASE_VALUE_TO_STRING(PRL_ERR_CORE_STATE_ERROR_COMMON);
        CASE_VALUE_TO_STRING(PRL_ERR_CORE_STATE_INV_SAV_VERSION);
        CASE_VALUE_TO_STRING(PRL_ERR_CORE_STATE_CORRUPT_SAV_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_CORE_STATE_CORRUPT_MEM_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_CORE_STATE_CHANGE_VM_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SUSPEND_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_RESUME_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_RESUME_INV_SAV_VERSION_CANCEL_RESUME);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SUSPEND_CHANGED_VM_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MEMORY_SWAPPING_IN_PROGRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_SUSPEND_VM_WITH_BOOTCAMP);
        CASE_VALUE_TO_STRING(PRL_ERR_SAFE_MODE_START_DURING_SUSPENDING_SYNC);
        CASE_VALUE_TO_STRING(PRL_ERR_CORE_STATE_VM_WOULD_STOP);
        CASE_VALUE_TO_STRING(PRL_ERR_RESUME_BOOTCAMP_CORRUPT_DISK_STATE_PARAM);
        CASE_VALUE_TO_STRING(PRL_ERR_RESUME_BOOTCAMP_CHANGED_DISK_CONTENTS);
        CASE_VALUE_TO_STRING(PRL_ERR_SUSPEND_BOOTCAMP_NOT_NTFS_ONLY_DISK);
        CASE_VALUE_TO_STRING(PRL_ERR_SUSPEND_BOOTCAMP_NTFS_RW_MOUNTERS_DETECTED);
        CASE_VALUE_TO_STRING(PRL_ERR_CORE_STATE_NO_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_CORE_STATE_CANCELLED);
        CASE_VALUE_TO_STRING(PRL_ERR_CORE_STATE_VM_WOULD_RESTART);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_GENERIC_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_XML_OPEN_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_XML_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_XML_INVALID_VERSION);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_XML_SAVE_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_XML_LARGE_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_SNAPSHOTS_CORRUPTED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_STORAGE_CORRUPTED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_IMAGES_CORRUPTED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_INVALID_BLOCKSIZE);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_STATES_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_INVALID_PARAMETERS);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_FILE_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_FILE_CREATE_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_FILE_OPEN_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_DIR_CREATE_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_CREATE_IMAGE_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_OPERATION_IN_PROGRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_BLOCK_SKIPPED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_BLOCK_PARTIALLY_PROCESSED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_MEMORY_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_DISK_NOT_OPENED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_INSUFFICIENT_SPACE);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_FAT32_SIZE_EXCEEDED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_NOT_PERMITTED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_INTERNAL_CLASS_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_WRITE_OUT_DISK);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_WRITE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_READ_OUT_DISK);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_READ_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_SET_CACHING_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_FSYNC_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_FULLFSYNC_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_INVALID_FORMAT);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_RENAME_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_OPERATION_NOT_ALLOWED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_OPERATION_ABORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_SHARING_VIOLATION);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_USER_INTERRUPTED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_XML_SAVE_REMOVE_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_XML_SAVE_RENAME_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_WRITE_REAL_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_NOT_IMPLEMENTED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_PARTITIONS_TABLE_CYCLE);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_IMAGE_BUSY);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_BLOCK_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_GROUP_INTERSECT);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_INCORRECTLY_CLOSED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_OFFSETS_FIXED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_CANT_INITIALIZE_IMAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_SMALL_IMAGE_SIZE);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_NULL_PART_SIZE);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_XML_LOCKED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_PARTITION_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_PARTITION_INVALID_NAME);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_UNALIGNED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_NOT_VALID_OFFSET);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_ENLARGE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_POSSIBLE_OVERRUN);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_BOOTCAMP_WRITE_MBR);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_IMPERSONATE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_XML_MISSING);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_UNCOMMITED_OPERATION);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_MOUNTED_OVERLAP);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_GET_SIZE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_GPT_MBR_NOT_EQUAL);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_XML_DIFFERS_FROM_REAL);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_XML_PARTITION_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_SHARED_BLOCK);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_COMPRESSED_FILE_EMPTY);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_TRUNCATE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_BLOCK_SEARCH_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_POINTERS_MIXED_UP);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_SET_FILE_SIZE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_DATA_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_RESERVED_WORD);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_GET_MOUNTPATH_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_MOUNT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_UNMOUNT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_GET_PARAMS_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_IDENTIFY_FAILED);
        CASE_VALUE_TO_STRING(PRL_CHECKED_DISK_VALID);
        CASE_VALUE_TO_STRING(PRL_CHECKED_DISK_OLD_VERSION);
        CASE_VALUE_TO_STRING(PRL_CHECKED_DISK_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_TRANSFER_CLIENT_NOT_CONNECTED);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_TRANSFER_CANT_LOCATE_SRC_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_TRANSFER_CANT_READ_SRC_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_TRANSFER_INVALID_CREDENTIALS);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_TRANSFER_CANT_CREATE_DST_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_TRANSFER_CANT_WRITE_DATA_TO_DST_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_TRANSFER_DST_FILE_ALREADY_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_TRANSFER_OPERATION_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_TRANSFER_UPLOAD_CANCELED_BY_USER);
        CASE_VALUE_TO_STRING(PRL_ERR_FILE_TRANSFER_INVALID_ARGUMENTS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_RESTRICTED_OS_VERSION);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_RESTRICTED_CPU_COUNT);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_RESTRICTED_MEMORY_SIZE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_RESTRICTED_UNDO_DISKS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_RESTRICTED_SMART_GUARD);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_VALIDATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_VM_NAME_IS_EMPTY);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_UNKNOWN_OS_TYPE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_UNKNOWN_OS_VERSION);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_VM_NAME_HAS_INVALID_SYMBOL);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_INVALID_DEVICE_MAIN_INDEX);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_DESKTOP_MODE_REMOTE_DEVICES);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_REAL_HARD_UNDO_DISKS_NOT_ALLOW);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_BOOTCAMP_HARD_UNDO_DISKS_NOT_ALLOW);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_INCOMPAT_HARD_UNDO_DISKS_NOT_ALLOW);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_BOOTCAMP_HARD_SNAPSHOTS_NOT_ALLOW);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_REAL_HARD_SAFE_MODE_NOT_ALLOW);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_BOOTCAMP_SAFE_MODE_NOT_ALLOW);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_INCOMPAT_SAFE_MODE_NOT_ALLOW);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NO_HD_IMAGES_IN_UNDO_DISKS_MODE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NO_HD_IMAGES_IN_SAFE_MODE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_BOOTCAMP_HARD_DISK_SMART_GUARD_NOT_ALLOW);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_INCOMPAT_HARD_DISK_SMART_GUARD_NOT_ALLOW);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_VIDEO_NOT_ENABLED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NO_AUTO_COMPRESS_WITH_UNDO_DISKS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NO_AUTO_COMPRESS_WITH_SMART_GUARD);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NO_SMART_GUARD_WITH_UNDO_DISKS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_CPUUNITS_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_CPULIMIT_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_IOPRIO_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_IOLIMIT_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VZ_API_NOT_INITIALIZED);
        CASE_VALUE_TO_STRING(PRL_ERR_CT_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_IOPSLIMIT_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_SAMPLE_CONFIG_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NEED_HEADLESS_MODE_FOR_AUTOSTART);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NEED_HEADLESS_MODE_FOR_AUTOSTOP);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NEED_HEADLESS_MODE_FOR_KEEP_VM_ALIVE_ON_GUI_EXIT);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_VM_NAME_IS_TOO_LONG);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NEED_MORE_MEMORY_TO_ENABLE_HOTPLUG);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_EFI_UNSUPPORTED_GUEST);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_BOOT_OPTION_INVALID_DEVICE_TYPE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_BOOT_OPTION_DUPLICATE_DEVICE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_BOOT_OPTION_DEVICE_NOT_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_AUTOSTART_FROM_CURRENT_USER_FORBIDDEN);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_REMOTE_DISPLAY_PORT_NUMBER_IS_ZERO);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_REMOTE_DISPLAY_HOST_IP_ADDRESS_IS_ZERO);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_REMOTE_DISPLAY_INVALID_HOST_IP_ADDRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_REMOTE_DISPLAY_EMPTY_PASSWORD);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_REMOTE_DISPLAY_PASSWORD_TOO_LONG);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SHARED_FOLDERS_EMPTY_FOLDER_NAME);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SHARED_FOLDERS_DUPLICATE_FOLDER_NAME);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SHARED_FOLDERS_INVALID_FOLDER_PATH);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SHARED_FOLDERS_DUPLICATE_FOLDER_PATH);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_CPU_ZERO_COUNT);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_CPU_COUNT_MORE_MAX_CPU_COUNT);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_CPU_COUNT_MORE_HOST_CPU_COUNT);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_CPU_MASK_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_CPU_MASK_INVALID_CPU_NUM);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_CPU_NODE_MASK_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_MAIN_MEMORY_ZERO_SIZE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_MAIN_MEMORY_OUT_OF_RANGE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_MAIN_MEMORY_NOT_4_RATIO_SIZE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_MAIN_MEMORY_SIZE_NOT_EAQUAL_RECOMMENDED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_MAIN_MEMORY_MAX_BALLOON_SIZE_MORE_100_PERCENT);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_MAIN_MEMORY_MQ_PRIOR_ZERO);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_MAIN_MEMORY_MQ_PRIOR_OUT_OF_RANGE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_MAIN_MEMORY_MQ_INVALID_RANGE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_MAIN_MEMORY_MQ_MIN_LESS_VMM_OVERHEAD_VALUE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_MAIN_MEMORY_MQ_MIN_OUT_OF_RANGE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_VIDEO_MEMORY_OUT_OF_RANGE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_FLOPPY_DISK_SYS_NAME_IS_EMPTY);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_FLOPPY_DISK_IMAGE_IS_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_FLOPPY_DISK_IS_NOT_ACCESSIBLE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_FLOPPY_DISK_IMAGE_IS_NOT_VALID);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_FLOPPY_DISK_SYS_NAME_HAS_INVALID_SYMBOL);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_FLOPPY_DISK_URL_FORMAT_SYS_NAME);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_CD_DVD_ROM_SYS_NAME_IS_EMPTY);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_CD_DVD_ROM_DUPLICATE_SYS_NAME);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_CD_DVD_ROM_IMAGE_IS_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_CD_DVD_ROM_URL_FORMAT_SYS_NAME);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_CD_DVD_ROM_SET_SATA_FOR_UNSUPPORTED_OS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_CD_DVD_ROM_SET_SATA_FOR_OLD_CHIPSET);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_HARD_DISK_SYS_NAME_IS_EMPTY);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_HARD_DISK_IMAGE_IS_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_HARD_DISK_IMAGE_IS_NOT_VALID);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_HARD_DISK_DUPLICATE_SYS_NAME);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_HARD_DISK_SYS_NAME_HAS_INVALID_SYMBOL);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_HARD_DISK_URL_FORMAT_SYS_NAME);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_HARD_DISK_WRONG_TYPE_BOOTCAMP_PARTITION);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_HARD_DISK_MISS_BOOTCAMP_PARTITION);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_HARD_DISK_WRONG_TYPE_FOR_ENCRYPTRED_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_HARD_DISK_NOT_ENOUGH_SPACE_FOR_ENCRYPT_DISK);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_HARD_DISK_SET_SATA_FOR_UNSUPPORTED_OS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_HARD_DISK_SET_SATA_FOR_OLD_CHIPSET);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_HARD_DISK_UNABLE_DELETE_DISK_WITH_SNAPSHOTS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_HARD_DISK_SERIAL_IS_NOT_VALID);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_BOUND_INDEX);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_MAC_ADDRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NETWORK_ADAPTER_DUPLICATE_MAC_ADDRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NETWORK_ADAPTER_DUPLICATE_IP_ADDRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NETWORK_ADAPTER_ETHLIST_CREATE_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_IP_ADDRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NETWORK_ADAPTER_GUEST_TOOLS_NOT_AVAILABLE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_DUPLICATE_IP_ADDRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NETWORK_ADAPTER_MULTICAST_IP_ADDRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NETWORK_ADAPTER_BROADCAST_IP_ADDRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_GATEWAY_IP_ADDRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NETWORK_ADAPTER_GATEWAY_NOT_IN_SUBNET);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_DNS_IP_ADDRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NETWORK_ADAPTER_INVALID_SEARCH_DOMAIN_NAME);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NETWORK_ADAPTER_ROUTED_NO_STATIC_ADDRESS);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SOUND_MIXER_IS_EMPTY);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SOUND_OUTPUT_IS_EMPTY);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SERIAL_PORT_SYS_NAME_IS_EMPTY);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SERIAL_PORT_IMAGE_IS_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SERIAL_PORT_SYS_NAME_HAS_INVALID_SYMBOL);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SERIAL_PORT_URL_FORMAT_SYS_NAME);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_PARALLEL_PORT_SYS_NAME_IS_EMPTY);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_PARALLEL_PORT_IMAGE_IS_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_PARALLEL_PORT_SYS_NAME_HAS_INVALID_SYMBOL);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_PARALLEL_PORT_URL_FORMAT_SYS_NAME);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_IDE_DEVICES_COUNT_OUT_OF_RANGE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_IDE_DEVICES_DUPLICATE_STACK_INDEX);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SATA_DEVICES_COUNT_OUT_OF_RANGE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SATA_DEVICES_DUPLICATE_STACK_INDEX);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_VIRTIO_BLOCK_DEVICES_DUPLICATE_STACK_INDEX);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SCSI_DEVICES_COUNT_OUT_OF_RANGE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SCSI_DEVICES_DUPLICATE_STACK_INDEX);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SCSI_BUSLOGIC_WITH_EFI_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_SCSI_HYPERV_LINUX_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_GENERIC_PCI_DEVICE_CANNOT_BE_ADDED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_GENERIC_PCI_DEVICE_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_GENERIC_PCI_DEVICE_NOT_CONNECTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_GENERIC_PCI_VIDEO_DEVICE_IS_ONE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_GENERIC_PCI_DEVICE_DUPLICATE_IN_ANOTHER_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_GENERIC_PCI_WRONG_DEVICE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_GENERIC_PCI_DUPLICATE_SYS_NAME);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_GENERIC_PCI_VIDEO_NOT_SINGLE);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NO_IP_ADDRESSES_SPECIFIED_FOR_OFFLINE_MANAGEMENT);
        CASE_VALUE_TO_STRING(PRL_WARN_NO_SHARED_NETWORK_FOR_OFFLINE_MANAGEMENT);
        CASE_VALUE_TO_STRING(PRL_ERR_VMCONF_NO_CONFIGURED_TOTALRATE_FOR_NETWORK_CLASS);
        CASE_VALUE_TO_STRING(PRL_ERR_TIS_INVALID_UID);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_COMPACT_PROCESSING);
        CASE_VALUE_TO_STRING(PRL_WARN_COMPACT_THROUGH_COPY);
        CASE_VALUE_TO_STRING(PRL_WARN_COMPACT_DESTRUCTIVE);
        CASE_VALUE_TO_STRING(PRL_ERR_IPFO_SOCKET_CREATE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_IPFO_SOCKET_BIND_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_IPFO_SOCKET_LISTEN_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_IPFO_SOCKET_ACCEPT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_IPFO_SOCKET_CONNECT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_IPFO_SOCKET_NOT_OPENED);
        CASE_VALUE_TO_STRING(PRL_ERR_IPFO_INVALID_MODE);
        CASE_VALUE_TO_STRING(PRL_ERR_IPFO_SEND_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_IPFO_RECEIVE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_IPC_CREATE_MAP_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_IPC_ATTACH_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_IPC_FTOK_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISP2DISP_SESSION_ALREADY_AUTHORIZED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISP2DISP_WRONG_USER_SESSION_UUID);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_CHECKING_PRECONDITIONS_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_NOT_ENOUGH_DISK_SPACE_ON_SOURCE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_OUT_OF_MEMORY_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_TARGET_VM_HOME_PATH_NOT_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_NOT_ENOUGH_CPUS_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_NON_COMPATIBLE_CPU_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_NETWORK_SHARE_IS_ABSENT_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_FLOPPY_DISK_IS_ABSENT_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_OPTICAL_DISK_IS_ABSENT_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_SERIAL_PORT_IS_ABSENT_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_PARALLEL_PORT_IS_ABSENT_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_NETWORK_ADAPTER_IS_ABSENT_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_USB_CONTROLLER_IS_ABSENT_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_SOUND_DEVICE_IS_ABSENT_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_VM_ALREADY_EXISTS_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_NOT_ENOUGH_DISK_SPACE_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_COULDNT_DETACH_TARGET_CONNECTION);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_UNSUITABLE_VM_STATE);
        CASE_VALUE_TO_STRING(PRL_ERR_FILECOPY_PROTOCOL);
        CASE_VALUE_TO_STRING(PRL_ERR_FILECOPY_DIR_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_FILECOPY_FILE_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_FILECOPY_CANT_CREATE_DIR);
        CASE_VALUE_TO_STRING(PRL_ERR_FILECOPY_CANT_OPEN_FILE);
        CASE_VALUE_TO_STRING(PRL_ERR_FILECOPY_CANT_WRITE);
        CASE_VALUE_TO_STRING(PRL_ERR_FILECOPY_INTERNAL);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_VM_UUID_ALREADY_EXISTS_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_VM_HOME_ALREADY_EXISTS_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_REMOTE_DEVICE_IS_ATTACHED);
        CASE_VALUE_TO_STRING(PRL_INFO_VM_MIGRATE_STORAGE_IS_SHARED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_RESUME_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_STORAGE_INFO_PARSE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_REGISTER_VM_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_SUSPEND_VM_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_RESUME_VM_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_VM_ALREADY_MIGRATE_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_CT_MIGRATE_INTERNAL_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_COPY_CT_TMPL_INTERNAL_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_CANNOT_REMOTE_CLONE_SHARED_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_CONTINUE_START_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_BREAK_BY_DISK_CONDITION);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_WARM_MODE_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_DEVICE_IMAGE_OUT_OF_BUNDLE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_INVALID_DISK_TYPE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_NON_COMPATIBLE_CPU_ON_TARGET_SHORT);
        CASE_VALUE_TO_STRING(PRL_ERR_CT_MIGRATE_ID_ALREADY_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_TO_THE_SAME_NODE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_ACCESS_TO_VM_DENIED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_ERROR_DELETE_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_ERROR_UNREGISTER_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_CT_MIGRATE_TARGET_ALREADY_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_EXTERNAL_DISKS_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_EXT_DISK_DIR_ALREADY_EXISTS_ON_TARGET);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_CANNOT_CREATE_DIRECTORY);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MIGRATE_TARGET_INSIDE_SHARED_VM_PRIVATE);
        CASE_VALUE_TO_STRING(PRL_ERR_CT_MIGRATE_EXTERNAL_PROCESS);
        CASE_VALUE_TO_STRING(PRL_ERR_IPHONE_PROXY_CANNOT_START);
        CASE_VALUE_TO_STRING(PRL_ERR_IPHONE_PROXY_CANNOT_STOP);
        CASE_VALUE_TO_STRING(PRL_ERR_IPHONE_PROXY_ALREADY_STARTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_TOOLS_CANT_PARSE_UPDATE_PARAMETERS);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_TOOLS_CANT_UPDATE_WITHOUT_RESTART);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_TOOL_NOT_AVAILABLE);
        CASE_VALUE_TO_STRING(PRL_ERR_ONLY_ADMIN_OR_VM_OWNER_CAN_OPEN_THIS_SESSION);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_EXEC_GUEST_TOOL_NOT_AVAILABLE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_GUEST_SESSION_EXPIRED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_EXEC_PROGRAM_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_GUEST_PROGRAM_EXECUTION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_SET_NETWORK_SETTINGS_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VNC_SERVER_ALREADY_STARTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VNC_SERVER_DISABLED);
        CASE_VALUE_TO_STRING(PRL_ERR_VNC_SERVER_AUTOSET_PORT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_FAILED_TO_START_VNC_SERVER);
        CASE_VALUE_TO_STRING(PRL_ERR_FAILED_TO_STOP_VNC_SERVER);
        CASE_VALUE_TO_STRING(PRL_ERR_VNC_SERVER_NOT_STARTED);
        CASE_VALUE_TO_STRING(PRL_WARN_FAILED_TO_START_VNC_SERVER);
        CASE_VALUE_TO_STRING(PRL_ERR_SUSPEND_VM_VTD_PAUSED);
        CASE_VALUE_TO_STRING(PRL_ERR_SUSPEND_VM_VTD_WITH_UNSUPPORTED_SHUTDOWN_TOOL);
        CASE_VALUE_TO_STRING(PRL_ERR_SUSPEND_VM_VTD_BY_GUEST_SLEEP_TIMEOUT);
        CASE_VALUE_TO_STRING(PRL_ERR_CREATE_SNAPSHOT_VM_VTD_PAUSED);
        CASE_VALUE_TO_STRING(PRL_ERR_CREATE_SNAPSHOT_VM_VTD_WITH_UNSUPPORTED_SHUTDOWN_TOOL);
        CASE_VALUE_TO_STRING(PRL_ERR_CREATE_SNAPSHOT_VM_VTD_BY_GUEST_SLEEP_TIMEOUT);
        CASE_VALUE_TO_STRING(PRL_ERR_SUSPEND_VM_VTD_WITH_UNLOADED_SHUTDOWN_TOOL);
        CASE_VALUE_TO_STRING(PRL_ERR_SUSPEND_VM_VTD_WITH_OUTDATED_SHUTDOWN_TOOL);
        CASE_VALUE_TO_STRING(PRL_ERR_CREATE_SNAPSHOT_VM_VTD_WITH_UNLOADED_SHUTDOWN_TOOL);
        CASE_VALUE_TO_STRING(PRL_ERR_CREATE_SNAPSHOT_VM_VTD_WITH_OUTDATED_SHUTDOWN_TOOL);
        CASE_VALUE_TO_STRING(PRL_ERR_REVERT_SNAPSHOT_VM_VTD_PAUSED);
        CASE_VALUE_TO_STRING(PRL_ERR_REVERT_SNAPSHOT_VM_VTD_BY_GUEST_SLEEP_TIMEOUT);
        CASE_VALUE_TO_STRING(PRL_ERR_REVERT_SNAPSHOT_VM_VTD_WITH_UNSUPPORTED_SHUTDOWN_TOOL);
        CASE_VALUE_TO_STRING(PRL_ERR_REVERT_SNAPSHOT_VM_VTD_WITH_UNLOADED_SHUTDOWN_TOOL);
        CASE_VALUE_TO_STRING(PRL_ERR_REVERT_SNAPSHOT_VM_VTD_WITH_OUTDATED_SHUTDOWN_TOOL);
        CASE_VALUE_TO_STRING(PRL_ERR_STAND_BY_VM_PAUSED);
        CASE_VALUE_TO_STRING(PRL_ERR_STAND_BY_VM_WITH_UNLOADED_SHUTDOWN_TOOL);
        CASE_VALUE_TO_STRING(PRL_ERR_STAND_BY_VM_WITH_OUTDATED_SHUTDOWN_TOOL);
        CASE_VALUE_TO_STRING(PRL_ERR_STAND_BY_VM_WITH_UNSUPPORTED_SHUTDOWN_TOOL);
        CASE_VALUE_TO_STRING(PRL_ERR_STAND_BY_VM_BY_GUEST_SLEEP_TIMEOUT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SHUTDOWN_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SHUTDOWN_MACHINE_LOCKED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SHUTDOWN_HIBERNATE_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SHUTDOWN_SUSPEND_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_SHUTDOWN_HIBERNATE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_SUSPEND_VM_VTD_WITH_UNSUPPORTED_CAPS);
        CASE_VALUE_TO_STRING(PRL_ERR_CREATE_SNAPSHOT_VM_VTD_WITH_UNSUPPORTED_CAPS);
        CASE_VALUE_TO_STRING(PRL_ERR_REVERT_SNAPSHOT_VM_VTD_WITH_UNSUPPORTED_CAPS);
        CASE_VALUE_TO_STRING(PRL_ERR_HVT_NOT_PRESENT_WARNING);
        CASE_VALUE_TO_STRING(PRL_ERR_SUSPEND_WITH_USB_BOOTDISK);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_INTERNAL_PROTO_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_INTERNAL_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_TIMEOUT_EXCEEDED);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_ACCESS_TO_VM_DENIED);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_BACKUP_UUID_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_CREATE_SNAPSHOT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_SWITCH_TO_SNAPSHOT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_REGISTER_VM_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_DIRECTORY_ALREADY_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_CANNOT_CREATE_DIRECTORY);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_RESTORE_VM_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_BACKUP_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_CANNOT_REMOVE_DIRECTORY);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_LOCKED_FOR_READING);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_LOCKED_FOR_WRITING);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_REQUIRE_LOGIN_PASSWORD);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_ACRONIS_ERR);
        CASE_VALUE_TO_STRING(PRL_WARN_BACKUP_HAS_NOT_FULL_BACKUP);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_BACKUP_CMD_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_RESTORE_CMD_FAILED);
        CASE_VALUE_TO_STRING(PRL_WARN_BACKUP_GUEST_SYNCHRONIZATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_SNAPSHOT_OF_PAUSED_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_FAILED_TO_CONNECT_TO_BACKUP_SERVER);
        CASE_VALUE_TO_STRING(PRL_ERR_FAILED_TO_AUTH_ON_BACKUP_SERVER);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_CANNOT_SET_PERMISSIONS);
        CASE_VALUE_TO_STRING(PRL_WARN_BACKUP_DEVICE_IMAGE_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_WARN_BACKUP_SP_GUEST_SYNCHRONIZATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_RESTORE_NOT_ENOUGH_FREE_DISK_SPACE);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_CREATE_NOT_ENOUGH_FREE_DISK_SPACE);
        CASE_VALUE_TO_STRING(PRL_WARN_BACKUP_GUEST_UNABLE_TO_SYNCHRONIZE);
        CASE_VALUE_TO_STRING(PRL_ERR_USER_NO_AUTH_TO_SAVE_BACKUP_FILES);
        CASE_VALUE_TO_STRING(PRL_ERR_PATH_IS_NOT_DIRECTORY);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_TOOL_CANNOT_START);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_CT_ID_ALREADY_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_REMOVE_PERMISSIONS_DENIED);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_BACKUP_HDD_IMAGE_OUT_OF_BUNDLE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_BACKUP_INVALID_DISK_TYPE);
        CASE_VALUE_TO_STRING(PRL_WARN_BACKUP_NON_IMAGE_HDD);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_RESTORE_INTERNAL_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_RESTORE_INTERNAL_PROTO_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_RESTORE_DIRECTORY_ALREADY_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_RESTORE_CANNOT_CREATE_DIRECTORY);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_RESTORE_PROHIBIT_WHEN_ATTACHED);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_RESTORE_EXISTING_SET_PRIVATE);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_UNSUPPORTED_KEEP_CHAIN);
        CASE_VALUE_TO_STRING(PRL_ERR_BACKUP_UNSUPPORTED_STORAGE_VERSION);
        CASE_VALUE_TO_STRING(PRL_ERR_HTTP_HOST_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_HTTP_CONNECTION_REFUSED);
        CASE_VALUE_TO_STRING(PRL_ERR_HTTP_UNEXPECTED_CLOSE);
        CASE_VALUE_TO_STRING(PRL_ERR_HTTP_INVALID_RESPONSE_HEADER);
        CASE_VALUE_TO_STRING(PRL_ERR_HTTP_WRONG_CONTENT_LENGTH);
        CASE_VALUE_TO_STRING(PRL_ERR_HTTP_PROXY_AUTH_REQUIRED);
        CASE_VALUE_TO_STRING(PRL_ERR_HTTP_AUTH_REQUIRED);
        CASE_VALUE_TO_STRING(PRL_ERR_HTTP_PROBLEM_REPORT_SEND_FAILURE);
        CASE_VALUE_TO_STRING(PRL_ERR_XMLRPC_WRONG_METHOD_CALL);
        CASE_VALUE_TO_STRING(PRL_ERR_XMLRPC_INVALID_CREDENTIALS);
        CASE_VALUE_TO_STRING(PRL_ERR_XMLRPC_LIMITS_EXHAUSTED);
        CASE_VALUE_TO_STRING(PRL_ERR_XMLRPC_INVALID_REQUEST_INFO);
        CASE_VALUE_TO_STRING(PRL_ERR_XMLRPC_INTERNAL_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_CLONE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_DELETE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_UNREGISTER);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_EDIT_COMMIT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_EXECUTE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_EXECUTE_EX);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_INTERNAL_REASON);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_EDIT_COMMIT_WITH_RENAME);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_UPDATE_SECURITY);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_MIGRATE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_CREATE_SNAPSHOT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_SWITCH_TO_SNAPSHOT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_DELETE_TO_SNAPSHOT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_BACKUP);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_RESTORE_FROM_BACKUP);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_CTL_FOR_BACKUP);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_DISK_RESIZE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_DISK_COMPACT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_DISK_CONVERT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_ENCRYPT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_DECRYPT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_CHANGE_PASSWORD);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_CHANGE_FIREWALL);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_COPY_IMAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_MOVE);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_SET_PROTECTION);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_LOCKED_FOR_REMOVE_PROTECTION);
        CASE_VALUE_TO_STRING(PRL_ERR_NOT_SENTILLION_CLIENT);
        CASE_VALUE_TO_STRING(PRL_ERR_CREATE_BOOTABLE_ISO);
        CASE_VALUE_TO_STRING(PRL_ERR_UNATTENDED_UNSUPPORTED_GUEST);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_RESIZER_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_RESIZE_WITH_SNAPSHOTS_NOT_ALLOWED);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_RESIZE_SIZE_TOO_LOW);
        CASE_VALUE_TO_STRING(PRL_ERR_DISK_RESIZE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_CONFIRMATION_MODE_UNABLE_CHANGE_BY_NOT_ADMIN);
        CASE_VALUE_TO_STRING(PRL_ERR_CONFIRMATION_MODE_ALREADY_ENABLED);
        CASE_VALUE_TO_STRING(PRL_ERR_CONFIRMATION_MODE_ALREADY_DISABLED);
        CASE_VALUE_TO_STRING(PRL_ERR_ADMIN_CONFIRMATION_IS_REQUIRED_FOR_OPERATION);
        CASE_VALUE_TO_STRING(PRL_ERR_ADMIN_CONFIRMATION_IS_REQUIRED_FOR_VM_OPERATION);
        CASE_VALUE_TO_STRING(PRL_ERR_CHANGESID_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_CHANGESID_GUEST_TOOLS_NOT_AVAILABLE);
        CASE_VALUE_TO_STRING(PRL_ERR_CHANGESID_VM_START_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_CHANGESID_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_CHANGESID_NOT_AVAILABLE);
        CASE_VALUE_TO_STRING(PRL_ERR_CONVERT_3RD_PARTY_VM_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_CONVERT_3RD_PARTY_VM_NO_SPACE);
        CASE_VALUE_TO_STRING(PRL_ERR_IMPORT_BOOTCAMP_VM_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_IMPORT_BOOTCAMP_VM_NO_SPACE);
        CASE_VALUE_TO_STRING(PRL_ERR_CONVERT_NO_GUEST_OS_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_CONVERT_EFI_CONFIG_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_CONVERT_EFI_GUEST_OS_UNSUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_CONVERT_GUEST_OS_IS_HIBERNATED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMHELPER_CREATEVM_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMHELPER_GETTING_AVAILABLE_DRIVE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMHELPER_DISK_MOUNT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMHELPER_DISK_UNMOUNT_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VMHELPER_DIR_PATH_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_INVALID_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_USER_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_DOWNLOAD_PARENT_PATH_NOT_DIR);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_DOWNLOAD_PARENT_PATH_NOT_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_DOWNLOAD_PATH_CANNOT_CREATE);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_DOWNLOAD_UTILITY_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_DOWNLOAD_UTILITY_NOT_STARTED);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_EXIT_WITH_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_CANNOT_EXTRACT_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_INSTALL_ALREADY_IN_PROCESS);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_CANNOT_CHANGE_OWNER);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_NAME_NOT_MATCH_VM_BUNDLE);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_CANNOT_MOVE_VM_BUNDLE);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_INSTALL_WAS_NOT_STARTED);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_CANNOT_CALCULATE_MD5);
        CASE_VALUE_TO_STRING(PRL_ERR_APPLIANCE_MISMATCH_MD5);
        CASE_VALUE_TO_STRING(PRL_ERR_CONV_HD_WRONG_VM_STATE);
        CASE_VALUE_TO_STRING(PRL_ERR_CONV_HD_EXIT_WITH_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_CONV_HD_NO_ONE_DISK_FOR_CONVERSION);
        CASE_VALUE_TO_STRING(PRL_ERR_CONV_HD_DISK_TOOL_NOT_STARTED);
        CASE_VALUE_TO_STRING(PRL_ERR_CONV_HD_CONFLICT);
        CASE_VALUE_TO_STRING(PRL_ERR_OBJECT_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_OBJECT_LIB_LOAD_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_OBJECT_LIB_NO_FUNCTIONS);
        CASE_VALUE_TO_STRING(PRL_ERR_OBJECT_DUPLICATE_UID);
        CASE_VALUE_TO_STRING(PRL_ERR_OBJECT_BAD_INTERFACE);
        CASE_VALUE_TO_STRING(PRL_ERR_OBJECT_LIB_WRONG_PERMS);
        CASE_VALUE_TO_STRING(PRL_ERR_OBJECT_LIB_CANT_GET_PERMS);
        CASE_VALUE_TO_STRING(PRL_ERR_OBJECT_DUPLICATE_CLASS);
        CASE_VALUE_TO_STRING(PRL_ERR_OBJECT_CLASS_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_PCMOVER_NOT_INSTALLED);
        CASE_VALUE_TO_STRING(PRL_ERR_PCMOVER_VAN_FILE_PREPARE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_PCMOVER_MIGRATE_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_PCMOVER_EXEC_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_PCMOVER_POLICY_FILE_WRITE_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_PCMOVER_POLICY_FILE_OPEN_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_PCMOVER_VAN_FILE_CREATE_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_PCMOVER_VAN_FILE_OPEN_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_PCMOVER_WINDOWS_DIR_NOT_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_TEST_TEXT_MESSAGES);
        CASE_VALUE_TO_STRING(PRL_ERR_TEST_TEXT_MESSAGES_PS);
        CASE_VALUE_TO_STRING(PRL_ERR_SET_CPULIMIT);
        CASE_VALUE_TO_STRING(PRL_ERR_SET_CPUUNITS);
        CASE_VALUE_TO_STRING(PRL_ERR_SET_IOPRIO);
        CASE_VALUE_TO_STRING(PRL_ERR_ACTION_NOT_SUPPORTED_FOR_CT);
        CASE_VALUE_TO_STRING(PRL_ERR_SET_IOLIMIT);
        CASE_VALUE_TO_STRING(PRL_ERR_SET_CPUMASK);
        CASE_VALUE_TO_STRING(PRL_ERR_VZ_OPERATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_VZ_OSTEMPLATE_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_CT_IS_RUNNING);
        CASE_VALUE_TO_STRING(PRL_ERR_UNNAMED_CT_MOVE);
        CASE_VALUE_TO_STRING(PRL_ERR_VZCTL_OPERATION_FAILED);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_LIBRARY);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_START);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_CREATE);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_REMOVE);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_MOUNT);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_UMOUNT);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_EXTEND);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_GET_STATE);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_MOUNTED);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_NOT_MOUNTED);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_INVALID_FSTYPE);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_ALREADY_REGISTERED);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_CANNOT_CREATE_MOUNT_POINT);
        CASE_VALUE_TO_STRING(PRL_ERR_ISCSI_STORAGE_MOUNT_POINT_ALREADY_EXISTS);
        CASE_VALUE_TO_STRING(PRL_ERR_UNSUPPORTED_VIRTUAL_SOURCE);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_UNPACK_ARCHIVE);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CONVERT_CONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CONVERT_OTHER_VENDOR_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_CONVERT_OTHER_VENDOR_HDD);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_RECONFIG_GUEST_OS);
        CASE_VALUE_TO_STRING(PRL_ERR_CANT_PREPARE_RECONFIG_DATA);
        CASE_VALUE_TO_STRING(PRL_ERR_NO_GUEST_OS_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_UNSUPPORTED_LAYOUTS_STRUCTURE);
        CASE_VALUE_TO_STRING(PRL_ERR_SOURCE_ISNT_BOOTCAMP_DISK);
        CASE_VALUE_TO_STRING(PRL_ERR_OS_RECONFIG_DATA_ABSENT);
        CASE_VALUE_TO_STRING(PRL_WRN_IT_FIRST_WARNING);
        CASE_VALUE_TO_STRING(PRL_WRN_IT_EMPTY_MBR);
        CASE_VALUE_TO_STRING(PRL_WRN_IT_VOLUME_RESIZING);
        CASE_VALUE_TO_STRING(PRL_WRN_IT_CANT_RESIZE_VOLUME);
        CASE_VALUE_TO_STRING(PRL_WRN_IT_CANT_RESIZE_LDM_DISK);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_FIRST_FAILURE);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_FAST_RESIZE_FAILURE);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_ROLLBACK_FAILURE);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_FIRST_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_USER_INTERRUPTED);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_SIZE_CHANGED);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_CANT_OPEN_IMAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_CANT_GET_PARAMS_FROM_OLD_IMAGE);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_GUEST_TOOLS_UNKNOWN_STATE);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_CANT_VALIDATE_BOOTCAMP);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_CANT_RECONFIG);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_CANT_RECONFIG_BOOTCAMP);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_CANT_PREPARE_RECONFIG_DATA);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_RECONFIG_PATH_NEEDED);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_UNKNOWN_OS);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_HAL_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_SNAPSHOTS_MERGE_IS_NEEDED);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_CONVERT_TO_CURRENT_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_DISK_SMALL_FOR_SPLIT);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_CANT_RESIZE_VOLUME);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_CANT_RESIZE_LDM_DISK);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_FS_NOT_SUPPORTED_FOR_RESIZE);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_CANT_COMPACT);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_CANT_COMPACT_LDM_DISK);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_CANT_GET_BITMAP);
        CASE_VALUE_TO_STRING(PRL_ERR_IT_CANT_COMPACT_PLAIN_DISK);
        CASE_VALUE_TO_STRING(PRL_ERR_TEMPLATE_HAS_APPS);
        CASE_VALUE_TO_STRING(PRL_ERR_TEMPLATE_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_MOUNT);
        CASE_VALUE_TO_STRING(PRL_ERR_VM_UNMOUNT);
        CASE_VALUE_TO_STRING(PRL_ERR_CONNECT_TO_MOUNTER);
        CASE_VALUE_TO_STRING(PRL_ERR_PERFORM_MOUNTER_COMMAND);
        CASE_VALUE_TO_STRING(PRL_ERR_MOUNTER_LIST_NO_OBJECT);
        CASE_VALUE_TO_STRING(PRL_ERR_CI_DEVICE_IS_NOT_VIRTUAL);
        CASE_VALUE_TO_STRING(PRL_ERR_CI_CANNOT_COPY_IMAGE_NON_STOPPED_VM);
        CASE_VALUE_TO_STRING(PRL_ERR_CI_PERMISSIONS_DENIED);
        CASE_VALUE_TO_STRING(PRL_ERR_CVSRC_IO_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_CVSRC_NO_OPEN_REQUEST);
        CASE_VALUE_TO_STRING(PRL_ERR_CVSRC_NO_CHANNEL);
        CASE_VALUE_TO_STRING(PRL_ERR_CLUSTER_RESOURCE_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_REG_PSTORAGE_REVOKE_IS_NEEDS);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_CREATED);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_ACCEPTED);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_BAD_REQUEST);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_NOT_FOUND);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_UNAUTHORIZED);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_INVALID_PARAMETERS);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_CONFLICT);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_SERVICE_UNAVAILABLE);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_INVALID_EMAIL);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_NO_CONTENT);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_FORBIDDEN);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_SOCIAL_CONFIRM_EMAIL_SENT);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_SOCIAL_UNCONFIRMED_ACCOUNT);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_SOCIAL_APP_DENIED);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_SOCIAL_SERVICE_BAD_RESPONSE);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_SOCIAL_SERVICE_UNAVAILABLE);
        CASE_VALUE_TO_STRING(PRL_ERR_WEB_PORTAL_SOCIAL_PROHIBITED_FOR_BA);
        CASE_VALUE_TO_STRING(PRL_ERR_SDK_TRY_AGAIN);
        CASE_VALUE_TO_STRING(PRL_ERR_BUSE_NOT_MOUNTED);
        CASE_VALUE_TO_STRING(PRL_ERR_BUSE_INTERNAL_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_BUSE_ENTRY_INVALID);
        CASE_VALUE_TO_STRING(PRL_ERR_BUSE_ENTRY_ALREADY_EXIST);
        CASE_VALUE_TO_STRING(PRL_ERR_BUSE_ENTRY_ALREADY_INITIALIZED);
        CASE_VALUE_TO_STRING(PRL_ERR_BUSE_ENTRY_IO_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_ATTACH_BACKUP_INTERNAL_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_ATTACH_BACKUP_INVALID_STORAGE_URL);
        CASE_VALUE_TO_STRING(PRL_ERR_ATTACH_BACKUP_CUSTOM_BACKUP_SERVER_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_ATTACH_BACKUP_PROTO_ERROR);
        CASE_VALUE_TO_STRING(PRL_ERR_ATTACH_BACKUP_FORMAT_NOT_SUPPORTED);
        CASE_VALUE_TO_STRING(PRL_ERR_ATTACH_BACKUP_ALREADY_ATTACHED);
        CASE_VALUE_TO_STRING(PRL_ERR_ATTACH_BACKUP_BUSE_NOT_MOUNTED);
        CASE_VALUE_TO_STRING(PRL_ERR_ATTACH_BACKUP_URL_CHANGE_PROHIBITED);
        CASE_VALUE_TO_STRING(PRL_ERR_CPUFEATURES_NO_BINARY);
        CASE_VALUE_TO_STRING(PRL_ERR_CPUFEATURES_INCORRECT_MASK);
        CASE_VALUE_TO_STRING(PRL_ERR_CPUFEATURES_POOLS_MANAGMENT);
        CASE_VALUE_TO_STRING(PRL_ERR_RUNNING_VM_OR_CT);
        CASE_VALUE_TO_STRING(PRL_ERR_CPUFEATURES_NOT_IN_POOLS);
        CASE_VALUE_TO_STRING(PRL_ERR_CPUFEATURES_DEFAULT_POOL_ARG);
        CASE_VALUE_TO_STRING(PRL_ERR_CPUFEATURES_INCOMPATIBLE_NODE);
        CASE_VALUE_TO_STRING(PRL_ERR_ENCRYPTION_COMMIT_REJECTED);
        CASE_VALUE_TO_STRING(PRL_ERR_ENCRYPTION_COMMIT_PROHIBITED);
        default:
            WRITE_TRACE(DBG_FATAL, "Unknown PRL_RESULT code %p", (void*)(ULONG_PTR)value) ;
            break ;
    }
    return "Unknown" ;
}


/**
 * Small utility method to transform event type to string
 */
const char * EventTypeToString(unsigned int value)
{
    switch ( value )
    {
        CASE_VALUE_TO_STRING(PET_VM_INF_UNINITIALIZED_EVENT_CODE);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_STATE_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_CONFIG_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_DEV_STATE_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_CREATED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_ADDED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_DELETED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_STARTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_STOPPED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_ABORTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_RESETED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_SUSPENDING);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_SUSPENDED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_RESUMING);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_RESUMED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_START_IO_FLOW);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_SNAPSHOTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_RESTORED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_NET_RECONNECTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_PAUSED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_CONTINUED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_CONFIG_APPLIED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_STATISTICS_UPDATED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_PROBLEM_REPORT_CREATED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_ABOUT_TO_RESET);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_SECURITY_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_UNREGISTERED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_REMOTE_DEV_READY_TO_START);
        CASE_VALUE_TO_STRING(PET_VM_EVT_VM_CONFIG_CHANGED);
        CASE_VALUE_TO_STRING(PET_VM_EVT_REQUEST_FILE_OPEN);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_MIGRATE_STARTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_MIGRATE_CANCELLED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_MIGRATE_FINISHED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_MIGRATE_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_SNAPSHOTING);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_RESTORING);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_SNAPSHOTS_TREE_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_DELETING_STATE);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_STATE_DELETED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_ABOUT_TO_START_DEINIT);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_ABOUT_TO_START_INIT);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_MEMORY_SWAPPING_STARTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_MEMORY_SWAPPING_FINISHED);
        CASE_VALUE_TO_STRING(PET_VM_EVT_UNMOUNT);
        CASE_VALUE_TO_STRING(PET_VM_EVT_MOUNT);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_REBOOT_HOST);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_REBOOT_HOST_MANUAL_TO_INIT_VTD_DEVICES);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_BACKUP_STARTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_BACKUP_CANCELLED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_CREATE_BACKUP_FINISHED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_BACKUP_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_JOB_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_RESTORE_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_DISK_RESIZE_STARTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_DISK_RESIZE_FINISHED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_DISK_RESIZE_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_ADDITION_STATE_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_RESTORE_BACKUP_FINISHED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_REMOVE_BACKUP_FINISHED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_MIGRATE_CANCELLED_DISP);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_MIGRATE_FINISHED_DISP);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_TIME_MACHINE_BACKUP_IS_OVER);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_CONVERSION_DISKS_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_CONVERSION_DISKS_PROGRESS_FINISHED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_CONVERT_THIRD_PARTY_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_CONNECTED_TO_PROXY);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_DISCONNECTED_FROM_PROXY);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_CONNECTING_TO_PROXY);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_RECONFIG_VM_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_MIGRATE_WAIT_REMOUNT);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_CONFIG_APPLY_FINISHED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_IO_CLIENT_STATISTICTS);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_SET_HOST_TIME);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_LOW_HOST_MEMORY);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_MAC_OS_VER);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_PAUSED_BY_HOST_SLEEP);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_CONTINUED_BY_HOST_WAKEUP);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_FROZEN);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_UNFROZEN);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_CONNECTION_CLIENT_INFO_WAS_SET);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_CONNECTION_WAS_CLOSED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_OP_ACCEPTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_OP_REJECTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_OP_RESULT);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_DIR_STATE_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_HOST_STATISTICS_UPDATED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_HW_CONFIG_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_CLIENT_CONNECTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_CLIENT_DISCONNECTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_CLIENT_REJECTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_FOUND_LOST_VM_CONFIG);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_HAS_EVENT);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_RECONNECT);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_DISP_CONNECTION_CLOSED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_DISP_SHUTDOWN);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_USER_PROFILE_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_COMMON_PREFS_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_MESSAGE);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_QUESTION);
        CASE_VALUE_TO_STRING(PET_JOB_DELETE_VM_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_VM_INF_START_FILE_COPYING);
        CASE_VALUE_TO_STRING(PET_VM_INF_END_FILE_COPYING);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_ERROR_MESSAGE);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_WARNING_MESSAGE);
        CASE_VALUE_TO_STRING(PET_JOB_HDD_CREATE_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_JOB_FILE_COPY_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_JOB_SUSPEND_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_JOB_RESUME_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_ANSWER_TO_VM_WAS_DONE);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_LICENSE_CHANGED);
        CASE_VALUE_TO_STRING(PET_JOB_CREATE_SNAPSHOT_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_JOB_SWITCH_TO_SNAPSHOT_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_JOB_DELETE_SNAPSHOT_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_JOB_COMMIT_UNFINISHED_DISK_OP_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_COMMIT_UNFINISHED_DISK_OP_STARTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_COMMIT_UNFINISHED_DISK_OP_FINISHED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_ENCRYPT_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_DECRYPT_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_JOB_STAGE_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_VM_INF_START_BUNCH_COPYING);
        CASE_VALUE_TO_STRING(PET_VM_INF_END_BUNCH_COPYING);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_SMC_USER_FORCE_DISCONNECTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_SMC_CANCEL_USER_COMMAND);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_SMC_DISPATCHER_SHUTDOWN);
        CASE_VALUE_TO_STRING(PET_IO_SCREEN_SIZE);
        CASE_VALUE_TO_STRING(PET_IO_SLIDING_MOUSE_FLAG);
        CASE_VALUE_TO_STRING(PET_IO_DEVICE_IS_IN_USE);
        CASE_VALUE_TO_STRING(PET_IO_KEYBOARD_LEDS);
        CASE_VALUE_TO_STRING(PET_IO_STATE);
        CASE_VALUE_TO_STRING(PET_IO_SCREEN_CAPTURED);
        CASE_VALUE_TO_STRING(PET_IO_BEFORE_SCREEN_SIZE);
        CASE_VALUE_TO_STRING(PET_IO_REMOTE_COMMAND);
        CASE_VALUE_TO_STRING(PET_IO_MOUSE_CURSOR_CHANGED);
        CASE_VALUE_TO_STRING(PET_IO_MOUSE_CURSOR_HID);
        CASE_VALUE_TO_STRING(PET_IO_MOUSE_CURSOR_SET);
        CASE_VALUE_TO_STRING(PET_IO_DYNRES_TOOL_STATUS);
        CASE_VALUE_TO_STRING(PET_IO_TOOLS_UTILITY_COMMAND);
        CASE_VALUE_TO_STRING(PET_IO_TOOLS_VM_SHUTDOWN);
        CASE_VALUE_TO_STRING(PET_IO_TOOLS_CLIPBOARD_DATA);
        CASE_VALUE_TO_STRING(PET_IO_SCREEN_SURFACE_DETACHED);
        CASE_VALUE_TO_STRING(PET_IO_TOOLS_SIA_DATA);
        CASE_VALUE_TO_STRING(PET_IO_TOOLS_VMCTG_COMMAND);
        CASE_VALUE_TO_STRING(PET_IO_TOOLS_DRAGDROP_DATA);
        CASE_VALUE_TO_STRING(PET_IO_TOOLS_GENERAL_COMMAND);
        CASE_VALUE_TO_STRING(PET_IO_TOOLS_DESKTOP_UTILITY_STATE);
        CASE_VALUE_TO_STRING(PET_IO_DISPLAY_SCREEN_SIZE);
        CASE_VALUE_TO_STRING(PET_IO_DISPLAY_BEFORE_SCREEN_SIZE);
        CASE_VALUE_TO_STRING(PET_IO_DISPLAY_SCREEN_CAPTURED);
        CASE_VALUE_TO_STRING(PET_IO_SWITCH_VESA_MODE);
        CASE_VALUE_TO_STRING(PET_IO_TOOLS_LANGUAGE_HOTKEY_CHANGED);
        CASE_VALUE_TO_STRING(PET_IO_AVAILABLE_DISPLAYS);
        CASE_VALUE_TO_STRING(PET_IO_SCREEN_SURFACE_ATTACHED);
        CASE_VALUE_TO_STRING(PET_IO_UIEMU_ELEMENT_AT_POS);
        CASE_VALUE_TO_STRING(PET_IO_AUDIO_OUTPUT_DATA);
        CASE_VALUE_TO_STRING(PET_IO_AUDIO_OUTPUT_ENCODING_SET);
        CASE_VALUE_TO_STRING(PET_IO_AUDIO_OUTPUT_STREAM_STARTED);
        CASE_VALUE_TO_STRING(PET_IO_AUDIO_OUTPUT_STOP);
        CASE_VALUE_TO_STRING(PET_IO_CVSRC_OPEN);
        CASE_VALUE_TO_STRING(PET_IO_CVSRC_CLOSE);
        CASE_VALUE_TO_STRING(PET_IO_SSO_GET_CREDENTIALS);
        CASE_VALUE_TO_STRING(PET_IO_MOUSE_CURSOR_MOVED);
        CASE_VALUE_TO_STRING(PET_IO_UIEMU_CARET_INFO);
        CASE_VALUE_TO_STRING(PET_IO_DISPLAY_GAMMA_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_TOOLS_STATE_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_COMPACT_PROCESSING);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_COMPACT_FINISHED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_COMPRESSOR_FINISHED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_COMPRESSOR_CONTINUED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_SOFTWARE_INSTALLED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_PIS_NOTIFICATION_ASK_TO_INSTALL);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_VIRTUAL_DEVICES_STATE_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_PERFSTATS);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_PERFSTATS);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_UPGRADE_INIT);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_UPGRADE_INIT_TIMEOUT);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_UPGRADE_STAGE_1);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_UPGRADE_STAGE_2);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_UPGRADE_STAGE_3);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_UPGRADE_COMPLETED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_UPGRADE_UNKNOWN_ERROR);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_UPGRADE_INIT_VMW);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_UPGRADE_INIT_PHY);
        CASE_VALUE_TO_STRING(PET_IO_READY_TO_ACCEPT_STDIN_PKGS);
        CASE_VALUE_TO_STRING(PET_VM_READY_TO_BOOT);
        CASE_VALUE_TO_STRING(PET_VM_READY_TO_PRINT);
        CASE_VALUE_TO_STRING(PET_VM_DEFAULT_SOUND_RECONNECTED);
        CASE_VALUE_TO_STRING(PET_VM_EVT_UNMOUNT_USB_MEDIA);
        CASE_VALUE_TO_STRING(PET_VM_EVT_UNMOUNT_DVD_MEDIA);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_APPLIANCE_DOWNLOAD_PROGRESS_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_APPLIANCE_DOWNLOAD_FINISHED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_APPLIANCE_ARCHIVE_UNPACK_STARTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_APPLIANCE_ARCHIVE_UNPACK_FINISHED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_APPLIANCE_REGISTER_VM_STARTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_APPLIANCE_REGISTER_VM_FINISHED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_CEP_WRITE_STRING);
        CASE_VALUE_TO_STRING(PET_DSP_COHERENCE_FAKE_STUB_NOTIFICATION);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_WAS_ENCRYPTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_WAS_DECRYPTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_ENCRYPTED_VM_PASSWORD_CHANGED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_ENCRYPTED_VM_NEED_AUTH_AGAIN);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_WAS_PROTECTED);
        CASE_VALUE_TO_STRING(PET_DSP_EVT_VM_WAS_UNPROTECTED);
        CASE_VALUE_TO_STRING(PET_VM_EVT_TIS_BACKUP_WRITE);
        CASE_VALUE_TO_STRING(PET_IO_EVT_DISCONNECT_WITH_REASON);
        CASE_VALUE_TO_STRING(PET_VIDEO_RECEIVER_FORMAT);
        CASE_VALUE_TO_STRING(PET_VIDEO_RECEIVER_FRAME);
        CASE_VALUE_TO_STRING(PET_VIDEO_RECEIVER_CLOSED);
        CASE_VALUE_TO_STRING(PET_VIDEO_CAPTURE_GEOMETRY);
        CASE_VALUE_TO_STRING(PET_VIDEO_RECEIVER_CONNECTION_STATE);
        CASE_VALUE_TO_STRING(PET_PTM_EVT_PROPERTY_CHANGED);
        CASE_VALUE_TO_STRING(PET_PTM_EVT_OBJECT_DELETED);
        CASE_VALUE_TO_STRING(PET_PTM_EVT_OBJECT_CREATED);
        CASE_VALUE_TO_STRING(PET_PTM_EVT_SUBSCRIBED);
        CASE_VALUE_TO_STRING(PET_PTM_EVT_RPC_COMPLETED);
        CASE_VALUE_TO_STRING(PET_IO_DISPLAY_PALETTE_CHANGED);
        CASE_VALUE_TO_STRING(PET_IO_TOOLS_TIS_QUERY);
        CASE_VALUE_TO_STRING(PET_IO_SCREEN_UPDATED);
        CASE_VALUE_TO_STRING(PET_IO_AUTH_RESPONSE);
        CASE_VALUE_TO_STRING(PET_IO_ATTACH_RESPONSE);
        CASE_VALUE_TO_STRING(PET_IO_ENCODING_RESPONSE);
        CASE_VALUE_TO_STRING(PET_IO_MEMORY_INFO);
        CASE_VALUE_TO_STRING(PET_IO_SCREEN_CAPTURED_BUFFER);
        CASE_VALUE_TO_STRING(PET_IO_TOOLS_TIS_SUBSCRIBE);
        CASE_VALUE_TO_STRING(PET_IO_TOOLS_TIS_UNSUBSCRIBE);
        CASE_VALUE_TO_STRING(PET_IO_CLI_AUTHENTICATE_SESSION);
        CASE_VALUE_TO_STRING(PET_IO_CLI_ATTACH_TO_VM);
        CASE_VALUE_TO_STRING(PET_IO_CLI_ENCODING_REQUEST);
        CASE_VALUE_TO_STRING(PET_IO_CLI_SCREEN_WATCH_UPDATES);
        CASE_VALUE_TO_STRING(PET_IO_CLI_SCREEN_CAPTURE_BUFFER);
        CASE_VALUE_TO_STRING(PET_IO_CLI_SCREEN_SIZE);
        CASE_VALUE_TO_STRING(PET_IO_CLI_KEYBOARD_SCANCODE);
        CASE_VALUE_TO_STRING(PET_IO_CLI_MOUSE_SETPOS);
        CASE_VALUE_TO_STRING(PET_IO_CLI_MOUSE_MOVE);
        CASE_VALUE_TO_STRING(PET_IO_CLI_MOUSE_NEED_CURSOR);
        CASE_VALUE_TO_STRING(PET_IO_CLI_GRACEFUL_SHUTDOWN);
        CASE_VALUE_TO_STRING(PET_IO_CLI_SCREEN_SET_SURFACE);
        CASE_VALUE_TO_STRING(PET_IO_CLI_REMOTE_COMMAND);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_UTILITY_COMMAND);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_TIS_QUERY);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_CLIPBOARD_DATA);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_SIA_DATA);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_VMCTG_COMMAND);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_GENERAL_COMMAND);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_EMPTY_RECYCLE_BIN);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_SET_TASKBAR_VISIBILITY);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_TOGGLE_DESKTOP);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_MOVE_TASKBAR);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_SHOW_RECYCLE_BIN);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_NOTIFY_COHERENCE_STATE);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_ADJUST_WORKING_AREA);
        CASE_VALUE_TO_STRING(PET_IO_CLI_KEYBOARD_KEY);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_UIEMU);
        CASE_VALUE_TO_STRING(PET_IO_CLI_CVSRC_CONNECT);
        CASE_VALUE_TO_STRING(PET_IO_CLI_CVSRC_DISCONNECT);
        CASE_VALUE_TO_STRING(PET_IO_CLI_AUTHENTICATE_EXEC_SESSION);
        CASE_VALUE_TO_STRING(PET_IO_CLI_SWITCH_SLIDING_MOUSE);
        CASE_VALUE_TO_STRING(PET_IO_CLI_SSO_SET_CREDENTIALS);
        CASE_VALUE_TO_STRING(PET_IO_CLI_SSO_SET_CREDENTIALS_ASYNC);
        CASE_VALUE_TO_STRING(PET_IO_CLI_SSO_LOCKED);
        CASE_VALUE_TO_STRING(PET_IO_CLI_SSO_UNLOCKED);
        CASE_VALUE_TO_STRING(PET_IO_CLI_DPI_SCREEN_SIZE);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_SET_INDENTS);
        CASE_VALUE_TO_STRING(PET_IO_CLI_AUDIO_RECORDING_STREAM_START);
        CASE_VALUE_TO_STRING(PET_IO_CLI_AUDIO_RECORDING_STREAM_STOP);
        CASE_VALUE_TO_STRING(PET_IO_CLI_AUDIO_PLAYOUT_STREAM_START);
        CASE_VALUE_TO_STRING(PET_IO_CLI_AUDIO_PLAYOUT_STREAM_STOP);
        CASE_VALUE_TO_STRING(PET_IO_CLI_TOOLS_OPEN_FILE_BROWSER);
        CASE_VALUE_TO_STRING(PET_IO_STDIN_PORTION);
        CASE_VALUE_TO_STRING(PET_IO_STDOUT_PORTION);
        CASE_VALUE_TO_STRING(PET_IO_STDERR_PORTION);
        CASE_VALUE_TO_STRING(PET_IO_READY_TO_ACCEPT_STDOUT_STDERR_PKGS);
        CASE_VALUE_TO_STRING(PET_IO_FIN_TO_TRANSMIT_STDOUT_STDERR);
        CASE_VALUE_TO_STRING(PET_IO_CLIENT_PROCESSED_ALL_DESCS_DATA);
        CASE_VALUE_TO_STRING(PET_IO_TTY_SETTINGS_REQUIRED);
        CASE_VALUE_TO_STRING(PET_IO_TTY_SETTINGS_PROVIDED);
        CASE_VALUE_TO_STRING(PET_IO_STDIN_WAS_CLOSED);
        CASE_VALUE_TO_STRING(PET_IT_RECONFIG_BOOTCAMP_START);
        CASE_VALUE_TO_STRING(PET_IT_VALIDATE_BOOTCAMP_START);
        CASE_VALUE_TO_STRING(PET_IT_CONVERT_TO_OLD_START);
        CASE_VALUE_TO_STRING(PET_IT_CONVERT_TO_CURRENT_START);
        CASE_VALUE_TO_STRING(PET_IT_RECONFIG_START);
        CASE_VALUE_TO_STRING(PET_IT_MERGE_SNAPSHOTS_START);
        CASE_VALUE_TO_STRING(PET_IT_MAKE_PLAIN_START);
        CASE_VALUE_TO_STRING(PET_IT_MAKE_EXPANDING_START);
        CASE_VALUE_TO_STRING(PET_IT_MAKE_SPLIT_START);
        CASE_VALUE_TO_STRING(PET_IT_MAKE_NON_SPLIT_START);
        CASE_VALUE_TO_STRING(PET_IT_GET_RESIZE_INFORMATION_START);
        CASE_VALUE_TO_STRING(PET_IT_INCREASE_LAST_VOLUME_START);
        CASE_VALUE_TO_STRING(PET_IT_RESIZING_START);
        CASE_VALUE_TO_STRING(PET_IT_DECREASING_START);
        CASE_VALUE_TO_STRING(PET_IT_COMPACTING_START);
        CASE_VALUE_TO_STRING(PET_IT_FIX_CONSISTENCY_START);
        CASE_VALUE_TO_STRING(PET_IT_CONVERT_TO_EXTEND_START);
        CASE_VALUE_TO_STRING(PET_DESKCTL_SESSION_AUTH);
        CASE_VALUE_TO_STRING(PET_DESKCTL_SESSION_AUTH_FIN);
        CASE_VALUE_TO_STRING(PET_DESKCTL_ATTACH);
        CASE_VALUE_TO_STRING(PET_DESKCTL_ATTACH_FIN);
        CASE_VALUE_TO_STRING(PET_DESKCTL_LOCAL_AUTH);
        CASE_VALUE_TO_STRING(PET_DESKCTL_LOCAL_AUTH_QUEST);
        CASE_VALUE_TO_STRING(PET_DESKCTL_LOCAL_AUTH_ANSWER);
        CASE_VALUE_TO_STRING(PET_DESKCTL_LOCAL_AUTH_FIN);
        CASE_VALUE_TO_STRING(PET_DESKCTL_ACCEPT_CLIENTS);
        CASE_VALUE_TO_STRING(PET_DESKCTL_REJECT_CLIENTS);
        CASE_VALUE_TO_STRING(PET_DESKCTL_CONFIG);
        CASE_VALUE_TO_STRING(PET_DESKCTL_CONFIG_QUERY);
        CASE_VALUE_TO_STRING(PET_DESKCTL_SEND_SAS);
        CASE_VALUE_TO_STRING(PET_DESKCTL_STATUS_CHANGE);
        CASE_VALUE_TO_STRING(PET_IO_DISCONNECT_WITH_REASON);
        CASE_VALUE_TO_STRING(PET_IO_DISPLAY_RESOLUTION_SET);
        CASE_VALUE_TO_STRING(PET_VIDEO_STREAM_START);
        CASE_VALUE_TO_STRING(PET_VIDEO_STREAM_CLOSE);
        CASE_VALUE_TO_STRING(PET_VIDEO_STREAM_FORMAT);
        CASE_VALUE_TO_STRING(PET_VIDEO_STREAM_DATA);
        CASE_VALUE_TO_STRING(PET_VIDEO_STREAM_CLOSED);
        CASE_VALUE_TO_STRING(PET_VIDEO_STREAM_ACK_FRAME);
        CASE_VALUE_TO_STRING(PET_VIDEO_STREAM_OPEN);
        CASE_VALUE_TO_STRING(PET_VIDEO_DATA_CHANNEL_CTL);
        CASE_VALUE_TO_STRING(PET_VIDEO_STREAM_STOP);
        CASE_VALUE_TO_STRING(PET_IO_PTM_PROTOCOL);
        CASE_VALUE_TO_STRING(PET_IO_IOSERVICE_CHANNELS_PROTOCOL);
        default:
            WRITE_TRACE(DBG_FATAL, "Unknown PRL_EVENT_TYPE value %p", (void*)(ULONG_PTR)value) ;
            break ;
    }

    return "Unknown" ;
}


/**
 * Small utility method to transform type to string
 */
const char * HandleTypeToString(unsigned int value)
{
    switch ( value )
    {
        CASE_VALUE_TO_STRING(PHT_ERROR);
        CASE_VALUE_TO_STRING(PHT_SERVER);
        CASE_VALUE_TO_STRING(PHT_SERVER_CONFIG);
        CASE_VALUE_TO_STRING(PHT_REMOTE_FILESYSTEM_INFO);
        CASE_VALUE_TO_STRING(PHT_REMOTE_FILESYSTEM_ENTRY);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_MACHINE);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DEV_DISPLAY);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DEV_KEYBOARD);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DEV_MOUSE);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DEV_FLOPPY);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DEV_HARD_DISK);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DEV_NET_ADAPTER);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DEV_PARALLEL_PORT);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DEV_SERIAL_PORT);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DEV_OPTICAL_DISK);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DEV_USB_DEVICE);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DEV_SOUND);
        CASE_VALUE_TO_STRING(PHT_JOB);
        CASE_VALUE_TO_STRING(PHT_EVENT);
        CASE_VALUE_TO_STRING(PHT_RESULT);
        CASE_VALUE_TO_STRING(PHT_VM_INFO);
        CASE_VALUE_TO_STRING(PHT_USER_PROFILE);
        CASE_VALUE_TO_STRING(PHT_DISP_CONFIG);
        CASE_VALUE_TO_STRING(PHT_SHARE);
        CASE_VALUE_TO_STRING(PHT_SCREEN_RESOLUTION);
        CASE_VALUE_TO_STRING(PHT_DISP_NET_ADAPTER);
        CASE_VALUE_TO_STRING(PHT_HW_GENERIC_DEVICE);
        CASE_VALUE_TO_STRING(PHT_HW_HARD_DISK);
        CASE_VALUE_TO_STRING(PHT_HW_HARD_DISK_PARTITION);
        CASE_VALUE_TO_STRING(PHT_HW_NET_ADAPTER);
        CASE_VALUE_TO_STRING(PHT_EVENT_PARAMETER);
        CASE_VALUE_TO_STRING(PHT_REMOTEDEV_CMD);
        CASE_VALUE_TO_STRING(PHT_SYSTEM_STATISTICS);
        CASE_VALUE_TO_STRING(PHT_SYSTEM_STATISTICS_CPU);
        CASE_VALUE_TO_STRING(PHT_SYSTEM_STATISTICS_IFACE);
        CASE_VALUE_TO_STRING(PHT_SYSTEM_STATISTICS_USER_SESSION);
        CASE_VALUE_TO_STRING(PHT_SYSTEM_STATISTICS_DISK);
        CASE_VALUE_TO_STRING(PHT_SYSTEM_STATISTICS_DISK_PARTITION);
        CASE_VALUE_TO_STRING(PHT_SYSTEM_STATISTICS_PROCESS);
        CASE_VALUE_TO_STRING(PHT_LICENSE);
        CASE_VALUE_TO_STRING(PHT_SERVER_INFO);
        CASE_VALUE_TO_STRING(PHT_BOOT_DEVICE);
        CASE_VALUE_TO_STRING(PHT_STRINGS_LIST);
        CASE_VALUE_TO_STRING(PHT_LOGIN_RESPONSE);
        CASE_VALUE_TO_STRING(PHT_RUNNING_TASK);
        CASE_VALUE_TO_STRING(PHT_NET_SERVICE_STATUS);
        CASE_VALUE_TO_STRING(PHT_HANDLES_LIST);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DISK);
        CASE_VALUE_TO_STRING(PHT_ACCESS_RIGHTS);
        CASE_VALUE_TO_STRING(PHT_VM_TOOLS_INFO);
        CASE_VALUE_TO_STRING(PHT_FOUND_VM_INFO);
        CASE_VALUE_TO_STRING(PHT_TIS_RECORD);
        CASE_VALUE_TO_STRING(PHT_USER_INFO);
        CASE_VALUE_TO_STRING(PHT_TIS_EMITTER);
        CASE_VALUE_TO_STRING(PHT_TOOL);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DEV_HD_PARTITION);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DEV_GENERIC_PCI);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DEV_GENERIC_SCSI);
        CASE_VALUE_TO_STRING(PHT_VM_GUEST_SESSION);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_NETWORK);
        CASE_VALUE_TO_STRING(PHT_PORT_FORWARDING);
        CASE_VALUE_TO_STRING(PHT_HW_GENERIC_PCI_DEVICE);
        CASE_VALUE_TO_STRING(PHT_OPAQUE_TYPE_LIST);
        CASE_VALUE_TO_STRING(PHT_GUEST_OSES_MATRIX);
        CASE_VALUE_TO_STRING(PHT_PROBLEM_REPORT);
        CASE_VALUE_TO_STRING(PHT_APPLIANCE_CONFIG);
        CASE_VALUE_TO_STRING(PHT_OFFLINE_SERVICE);
        CASE_VALUE_TO_STRING(PHT_VM_VIRTUAL_DEVICES_INFO);
        CASE_VALUE_TO_STRING(PHT_NETWORK_CLASS);
        CASE_VALUE_TO_STRING(PHT_NETWORK_SHAPING);
        CASE_VALUE_TO_STRING(PHT_NETWORK_RATE);
        CASE_VALUE_TO_STRING(PHT_ISCSI_LUN);
        CASE_VALUE_TO_STRING(PHT_CT_TEMPLATE);
        CASE_VALUE_TO_STRING(PHT_USB_IDENTITY);
        CASE_VALUE_TO_STRING(PHT_FIREWALL_RULE);
        CASE_VALUE_TO_STRING(PHT_IPPRIV_NET);
        CASE_VALUE_TO_STRING(PHT_PLUGIN_INFO);
        CASE_VALUE_TO_STRING(PHT_CVSRC);
        CASE_VALUE_TO_STRING(PHT_DESKTOP_CONTROL);
        CASE_VALUE_TO_STRING(PHT_BACKUP_RESULT);
        CASE_VALUE_TO_STRING(PHT_NETWORK_SHAPING_CONFIG);
        CASE_VALUE_TO_STRING(PHT_NETWORK_SHAPING_BANDWIDTH);
        CASE_VALUE_TO_STRING(PHT_SYSTEM_STATISTICS_VM_DATA);
        CASE_VALUE_TO_STRING(PHT_VIDEO_RECEIVER);
        CASE_VALUE_TO_STRING(PHT_SESSION_INFO);
        CASE_VALUE_TO_STRING(PHT_CPU_FEATURES);
        CASE_VALUE_TO_STRING(PHT_CPU_POOL);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DISK_MAP);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DISK_OPEN_POLICY);
        CASE_VALUE_TO_STRING(PHT_VIRTUAL_DISK_ENCRYPTION);
        CASE_VALUE_TO_STRING(PHT_VCMMD_CONFIG);
        CASE_VALUE_TO_STRING(PHT_BACKUP);
        default:
            WRITE_TRACE(DBG_FATAL, "Unknown PRL_HANDLE_TYPE value %p", (void*)(ULONG_PTR)value) ;
            break ;
    }

    return "Unknown" ;
}

/**
 * Small utility method to transform type to string
 */
const char * VmStateToString(unsigned int value)
{
    switch ( value )
    {
        CASE_VALUE_TO_STRING(VMS_UNKNOWN);
        CASE_VALUE_TO_STRING(VMS_STOPPED);
        CASE_VALUE_TO_STRING(VMS_STARTING);
        CASE_VALUE_TO_STRING(VMS_RESTORING);
        CASE_VALUE_TO_STRING(VMS_RUNNING);
        CASE_VALUE_TO_STRING(VMS_PAUSED);
        CASE_VALUE_TO_STRING(VMS_SUSPENDING);
        CASE_VALUE_TO_STRING(VMS_STOPPING);
        CASE_VALUE_TO_STRING(VMS_COMPACTING);
        CASE_VALUE_TO_STRING(VMS_SUSPENDED);
        CASE_VALUE_TO_STRING(VMS_SNAPSHOTING);
        CASE_VALUE_TO_STRING(VMS_RESETTING);
        CASE_VALUE_TO_STRING(VMS_PAUSING);
        CASE_VALUE_TO_STRING(VMS_CONTINUING);
        CASE_VALUE_TO_STRING(VMS_MIGRATING);
        CASE_VALUE_TO_STRING(VMS_DELETING_STATE);
        CASE_VALUE_TO_STRING(VMS_RESUMING);
        CASE_VALUE_TO_STRING(VMS_SUSPENDING_SYNC);
        CASE_VALUE_TO_STRING(VMS_RECONNECTING);
        CASE_VALUE_TO_STRING(VMS_MOUNTED);
        default:
            WRITE_TRACE(DBG_FATAL, "Unknown VIRTUAL_MACHINE_STATE value %p", (void*)(ULONG_PTR)value) ;
            break ;
    }

    return "Unknown" ;
}

/**
 * Small utility method to transform type to string
 */
const char * JobOperationCodeToString(unsigned int value)
{
    switch ( value )
    {
        CASE_VALUE_TO_STRING(PJOC_UNKNOWN);
        CASE_VALUE_TO_STRING(PJOC_JOB_CANCEL);
        CASE_VALUE_TO_STRING(PJOC_SRV_LOOKUP_PARALLELS_SERVERS);
        CASE_VALUE_TO_STRING(PJOC_SRV_LOGIN);
        CASE_VALUE_TO_STRING(PJOC_SRV_LOGIN_LOCAL);
        CASE_VALUE_TO_STRING(PJOC_SRV_LOGOFF);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_SRV_CONFIG);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_COMMON_PREFS);
        CASE_VALUE_TO_STRING(PJOC_SRV_COMMON_PREFS_BEGIN_EDIT);
        CASE_VALUE_TO_STRING(PJOC_SRV_COMMON_PREFS_COMMIT);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_USER_PROFILE);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_STATISTICS);
        CASE_VALUE_TO_STRING(PJOC_SRV_USER_PROFILE_BEGIN_EDIT);
        CASE_VALUE_TO_STRING(PJOC_SRV_USER_PROFILE_COMMIT);
        CASE_VALUE_TO_STRING(PJOC_SRV_REGISTER_VM);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_VM_LIST);
        CASE_VALUE_TO_STRING(PJOC_SRV_SUBSCRIBE_TO_HOST_STATISTICS);
        CASE_VALUE_TO_STRING(PJOC_SRV_UNSUBSCRIBE_FROM_HOST_STATISTICS);
        CASE_VALUE_TO_STRING(PJOC_SRV_SHUTDOWN);
        CASE_VALUE_TO_STRING(PJOC_SRV_FS_GET_DISK_LIST);
        CASE_VALUE_TO_STRING(PJOC_SRV_FS_GET_DIR_ENTRIES);
        CASE_VALUE_TO_STRING(PJOC_SRV_FS_CREATE_DIR);
        CASE_VALUE_TO_STRING(PJOC_SRV_FS_REMOVE_ENTRY);
        CASE_VALUE_TO_STRING(PJOC_SRV_FS_CAN_CREATE_FILE);
        CASE_VALUE_TO_STRING(PJOC_SRV_FS_RENAME_ENTRY);
        CASE_VALUE_TO_STRING(PJOC_SRV_FS_GENERATE_ENTRY_NAME);
        CASE_VALUE_TO_STRING(PJOC_SRV_UPDATE_LICENSE);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_LICENSE_INFO);
        CASE_VALUE_TO_STRING(PJOC_SRV_SEND_ANSWER);
        CASE_VALUE_TO_STRING(PJOC_SRV_START_SEARCH_VMS);
        CASE_VALUE_TO_STRING(PJOC_SRV_NET_SERVICE_START);
        CASE_VALUE_TO_STRING(PJOC_SRV_NET_SERVICE_STOP);
        CASE_VALUE_TO_STRING(PJOC_SRV_NET_SERVICE_RESTART);
        CASE_VALUE_TO_STRING(PJOC_SRV_NET_SERVICE_RESTORE_DEFAULTS);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_NET_SERVICE_STATUS);
        CASE_VALUE_TO_STRING(PJOC_SRV_ADD_NET_ADAPTER);
        CASE_VALUE_TO_STRING(PJOC_SRV_DELETE_NET_ADAPTER);
        CASE_VALUE_TO_STRING(PJOC_SRV_UPDATE_NET_ADAPTER);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_PROBLEM_REPORT);
        CASE_VALUE_TO_STRING(PJOC_SRV_ATTACH_TO_LOST_TASK);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_USER_INFO_LIST);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_USER_INFO);
        CASE_VALUE_TO_STRING(PJOC_VM_START);
        CASE_VALUE_TO_STRING(PJOC_VM_STOP);
        CASE_VALUE_TO_STRING(PJOC_VM_PAUSE);
        CASE_VALUE_TO_STRING(PJOC_VM_RESET);
        CASE_VALUE_TO_STRING(PJOC_VM_SUSPEND);
        CASE_VALUE_TO_STRING(PJOC_VM_DROP_SUSPENDED_STATE);
        CASE_VALUE_TO_STRING(PJOC_VM_CLONE);
        CASE_VALUE_TO_STRING(PJOC_VM_DELETE);
        CASE_VALUE_TO_STRING(PJOC_VM_GET_PROBLEM_REPORT);
        CASE_VALUE_TO_STRING(PJOC_VM_GET_STATE);
        CASE_VALUE_TO_STRING(PJOC_VM_GENERATE_VM_DEV_FILENAME);
        CASE_VALUE_TO_STRING(PJOC_VM_GET_TOOLS_STATE);
        CASE_VALUE_TO_STRING(PJOC_VM_REFRESH_CONFIG);
        CASE_VALUE_TO_STRING(PJOC_VM_GET_STATISTICS);
        CASE_VALUE_TO_STRING(PJOC_VM_SUBSCRIBE_TO_GUEST_STATISTICS);
        CASE_VALUE_TO_STRING(PJOC_VM_UNSUBSCRIBE_FROM_GUEST_STATISTICS);
        CASE_VALUE_TO_STRING(PJOC_VM_REG);
        CASE_VALUE_TO_STRING(PJOC_VM_UNREG);
        CASE_VALUE_TO_STRING(PJOC_VM_BEGIN_EDIT);
        CASE_VALUE_TO_STRING(PJOC_VM_COMMIT);
        CASE_VALUE_TO_STRING(PJOC_VM_CREATE_UNATTENDED_FLOPPY);
        CASE_VALUE_TO_STRING(PJOC_VM_INITIATE_DEV_STATE_NOTIFICATIONS);
        CASE_VALUE_TO_STRING(PJOC_VM_UPDATE_SECURITY);
        CASE_VALUE_TO_STRING(PJOC_VM_VALIDATE_CONFIG);
        CASE_VALUE_TO_STRING(PJOC_VM_DEV_CONNECT);
        CASE_VALUE_TO_STRING(PJOC_VM_DEV_DISCONNECT);
        CASE_VALUE_TO_STRING(PJOC_VM_DEV_CREATE_IMAGE);
        CASE_VALUE_TO_STRING(PJOC_VM_INSTALL_TOOLS);
        CASE_VALUE_TO_STRING(PJOC_VM_SEND_SHUTDOWN_COMMAND);
        CASE_VALUE_TO_STRING(PJOC_VM_SEND_CLIPBOARD_REQUEST);
        CASE_VALUE_TO_STRING(PJOC_VM_CONNECT_TO_VM);
        CASE_VALUE_TO_STRING(PJOC_VM_DEV_DISPLAY_CAPTURE_SCREEN);
        CASE_VALUE_TO_STRING(PJOC_VM_MIGRATE);
        CASE_VALUE_TO_STRING(PJOC_VM_SEND_DRAGDROP_COMMAND);
        CASE_VALUE_TO_STRING(PJOC_VM_GUEST_RUN_PROGRAM);
        CASE_VALUE_TO_STRING(PJOC_VM_GUEST_LOGOUT);
        CASE_VALUE_TO_STRING(PJOC_SRV_SUBSCRIBE_PERFSTATS);
        CASE_VALUE_TO_STRING(PJOC_SRV_UNSUBSCRIBE_PERFSTATS);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_PERFSTATS);
        CASE_VALUE_TO_STRING(PJOC_VM_SUBSCRIBE_PERFSTATS);
        CASE_VALUE_TO_STRING(PJOC_VM_UNSUBSCRIBE_PERFSTATS);
        CASE_VALUE_TO_STRING(PJOC_VM_GET_PERFSTATS);
        CASE_VALUE_TO_STRING(PJOC_VM_GET_SUSPENDED_SCREEN);
        CASE_VALUE_TO_STRING(PJOC_VM_MIGRATE_CANCEL);
        CASE_VALUE_TO_STRING(PJOC_VM_RUN_COMPRESSOR);
        CASE_VALUE_TO_STRING(PJOC_VM_CANCEL_COMPRESSOR);
        CASE_VALUE_TO_STRING(PJOC_VM_CREATE_SNAPSHOT);
        CASE_VALUE_TO_STRING(PJOC_VM_SWITCH_TO_SNAPSHOT);
        CASE_VALUE_TO_STRING(PJOC_VM_DELETE_SNAPSHOT);
        CASE_VALUE_TO_STRING(PJOC_VM_GET_SNAPSHOTS_TREE);
        CASE_VALUE_TO_STRING(PJOC_VM_START_EX);
        CASE_VALUE_TO_STRING(PJOC_VM_LOGIN_IN_GUEST);
        CASE_VALUE_TO_STRING(PJOC_VM_UPDATE_SNAPSHOT_DATA);
        CASE_VALUE_TO_STRING(PJOC_VM_RESTART);
        CASE_VALUE_TO_STRING(PJOC_VM_INSTALL_UTILITY);
        CASE_VALUE_TO_STRING(PJOC_VM_UPDATE_TOOLS_SECTION);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_ALL_HOST_USERS);
        CASE_VALUE_TO_STRING(PJOC_VM_RESTORE);
        CASE_VALUE_TO_STRING(PJOC_VM_START_VNC_SERVER);
        CASE_VALUE_TO_STRING(PJOC_VM_STOP_VNC_SERVER);
        CASE_VALUE_TO_STRING(PJOC_VM_GUEST_GET_NETWORK_SETTINGS);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_VIRTUAL_NETWORK_LIST);
        CASE_VALUE_TO_STRING(PJOC_VM_AUTH_WITH_GUEST_SECURITY_DB);
        CASE_VALUE_TO_STRING(PJOC_VM_GUEST_SET_USER_PASSWD);
        CASE_VALUE_TO_STRING(PJOC_SRV_ADD_VIRTUAL_NETWORK);
        CASE_VALUE_TO_STRING(PJOC_SRV_UPDATE_VIRTUAL_NETWORK);
        CASE_VALUE_TO_STRING(PJOC_SRV_DELETE_VIRTUAL_NETWORK);
        CASE_VALUE_TO_STRING(PJOC_SRV_CONFIGURE_GENERIC_PCI);
        CASE_VALUE_TO_STRING(PJOC_SRV_PREPARE_FOR_HIBERNATE);
        CASE_VALUE_TO_STRING(PJOC_SRV_AFTER_HOST_RESUME);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_BACKUP_TREE);
        CASE_VALUE_TO_STRING(PJOC_SRV_CREATE_VM_BACKUP);
        CASE_VALUE_TO_STRING(PJOC_SRV_RESTORE_VM_BACKUP);
        CASE_VALUE_TO_STRING(PJOC_API_SEND_PROBLEM_REPORT);
        CASE_VALUE_TO_STRING(PJOC_VM_LOCK);
        CASE_VALUE_TO_STRING(PJOC_VM_UNLOCK);
        CASE_VALUE_TO_STRING(PJOC_SRV_SET_NON_INTERACTIVE_SESSION);
        CASE_VALUE_TO_STRING(PJOC_SRV_CREATE_UNATTENDED_CD);
        CASE_VALUE_TO_STRING(PJOC_SRV_REMOVE_VM_BACKUP);
        CASE_VALUE_TO_STRING(PJOC_VM_RESIZE_DISK_IMAGE);
        CASE_VALUE_TO_STRING(PJOC_SRV_SET_SESSION_CONFIRMATION_MODE);
        CASE_VALUE_TO_STRING(PJOC_SRV_STORE_VALUE_BY_KEY);
        CASE_VALUE_TO_STRING(PJOC_VM_STORE_VALUE_BY_KEY);
        CASE_VALUE_TO_STRING(PJOC_VM_COMPACT);
        CASE_VALUE_TO_STRING(PJOC_VM_CANCEL_COMPACT);
        CASE_VALUE_TO_STRING(PJOC_SRV_SEND_CLIENT_STATISTICS);
        CASE_VALUE_TO_STRING(PJOC_VM_GET_PACKED_PROBLEM_REPORT);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_PACKED_PROBLEM_REPORT);
        CASE_VALUE_TO_STRING(PJOC_API_SEND_PACKED_PROBLEM_REPORT);
        CASE_VALUE_TO_STRING(PJOC_SRV_UPDATE_USB_ASSOC_LIST);
        CASE_VALUE_TO_STRING(PJOC_SRV_REGISTER_3RD_PARTY_VM);
        CASE_VALUE_TO_STRING(PJOC_VM_CHANGE_SID);
        CASE_VALUE_TO_STRING(PJOC_VM_RESET_UPTIME);
        CASE_VALUE_TO_STRING(PJOC_REPORT_ASSEMBLY);
        CASE_VALUE_TO_STRING(PJOC_SRV_INSTALL_APPLIANCE);
        CASE_VALUE_TO_STRING(PJOC_SRV_UPDATE_OFFLINE_SERVICE);
        CASE_VALUE_TO_STRING(PJOC_SRV_DELETE_OFFLINE_SERVICE);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_OFFLINE_SERVICES_LIST);
        CASE_VALUE_TO_STRING(PJOC_SRV_START_CLUSTER_SERVICE);
        CASE_VALUE_TO_STRING(PJOC_SRV_STOP_CLUSTER_SERVICE);
        CASE_VALUE_TO_STRING(PJOC_VM_CMD_INTERNAL);
        CASE_VALUE_TO_STRING(PJOC_VM_GET_VIRTUAL_DEVICES_INFO);
        CASE_VALUE_TO_STRING(PJOC_VM_CONVERT_DISKS);
        CASE_VALUE_TO_STRING(PJOC_SRV_UPDATE_NETWORK_CLASSES_CONFIG);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_NETWORK_CLASSES_LIST);
        CASE_VALUE_TO_STRING(PJOC_SRV_UPDATE_NETWORK_SHAPING_CONFIG);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_NETWORK_SHAPING_CONFIG);
        CASE_VALUE_TO_STRING(PJOC_SRV_RESTART_NETWORK_SHAPING);
        CASE_VALUE_TO_STRING(PJOC_SRV_PROXY_GET_REGISTERED_HOSTS);
        CASE_VALUE_TO_STRING(PJOC_SRV_REGISTER_ISCSI_STORAGE);
        CASE_VALUE_TO_STRING(PJOC_SRV_UNREGISTER_ISCSI_STORAGE);
        CASE_VALUE_TO_STRING(PJOC_SRV_EXTEND_ISCSI_STORAGE);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_CT_TEMPLATE_LIST);
        CASE_VALUE_TO_STRING(PJOC_SRV_CHECK_ALIVE);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_DEFAULT_VM_CONFIG);
        CASE_VALUE_TO_STRING(PJOC_SRV_REMOVE_CT_TEMPLATE);
        CASE_VALUE_TO_STRING(PJOC_SRV_COPY_CT_TEMPLATE);
        CASE_VALUE_TO_STRING(PJOC_SRV_ADD_IPPRIVATE_NETWORK);
        CASE_VALUE_TO_STRING(PJOC_SRV_REMOVE_IPPRIVATE_NETWORK);
        CASE_VALUE_TO_STRING(PJOC_SRV_UPDATE_IPPRIVATE_NETWORK);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_IPPRIVATE_NETWORKS_LIST);
        CASE_VALUE_TO_STRING(PJOC_VM_DEV_COPY_IMAGE);
        CASE_VALUE_TO_STRING(PJOC_SRV_REFRESH_PLUGINS);
        CASE_VALUE_TO_STRING(PJOC_VM_MOUNT);
        CASE_VALUE_TO_STRING(PJOC_VM_UMOUNT);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_PLUGINS_LIST);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_DISK_FREE_SPACE);
        CASE_VALUE_TO_STRING(PJOC_DESKTOP_CONTROL_CONNECT);
        CASE_VALUE_TO_STRING(PJOC_VM_MOVE);
        CASE_VALUE_TO_STRING(PJOC_SRV_GENERATE_CSR);
        CASE_VALUE_TO_STRING(PJOC_SRV_SIGN_CERTIFICATION_REQUEST);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_VM_CONFIG);
        CASE_VALUE_TO_STRING(PJOC_PTM_RPC);
        CASE_VALUE_TO_STRING(PJOC_API_PUT_USER_DATA);
        CASE_VALUE_TO_STRING(PJOC_API_GET_USER_DATA);
        CASE_VALUE_TO_STRING(PJOC_API_GET_USER_KEYS);
        CASE_VALUE_TO_STRING(PJOC_API_REMOVE_USER_DATA);
        CASE_VALUE_TO_STRING(PJOC_API_PUT_ICON);
        CASE_VALUE_TO_STRING(PJOC_API_VALIDATE_IN_CACHE);
        CASE_VALUE_TO_STRING(PJOC_SRV_UPDATE_SESSION_INFO);
        CASE_VALUE_TO_STRING(PJOC_API_SUBSCRIBE_ON_REGISTRATION);
        CASE_VALUE_TO_STRING(PJOC_SRV_SEND_PROBLEM_REPORT);
        CASE_VALUE_TO_STRING(PJOC_VM_SEND_PROBLEM_REPORT);
        CASE_VALUE_TO_STRING(PJOC_VM_SET_PROTECTION);
        CASE_VALUE_TO_STRING(PJOC_VM_REMOVE_PROTECTION);
        CASE_VALUE_TO_STRING(PJOC_SRV_CPU_POOLS_LIST_POOLS);
        CASE_VALUE_TO_STRING(PJOC_SRV_CPU_POOLS_MOVE);
        CASE_VALUE_TO_STRING(PJOC_SRV_CPU_POOLS_RECALCULATE);
        CASE_VALUE_TO_STRING(PJOC_SRV_CPU_POOLS_JOIN);
        CASE_VALUE_TO_STRING(PJOC_SRV_CPU_POOLS_LEAVE);
        CASE_VALUE_TO_STRING(PJOC_VM_COMMIT_ENCRYPTION);
        CASE_VALUE_TO_STRING(PJOC_SRV_GET_VCMMD_CONFIG);
        CASE_VALUE_TO_STRING(PJOC_CT_REINSTALL);
        CASE_VALUE_TO_STRING(PJOC_SRV_BEGIN_VM_BACKUP);
        CASE_VALUE_TO_STRING(PJOC_VM_END_BACKUP);
        default:
            WRITE_TRACE(DBG_FATAL, "Unknown PRL_JOB_OPERATION_CODE value %p", (void*)(ULONG_PTR)value) ;
            break ;
    }

    return "Unknown" ;
}

#ifdef __cplusplus
}
#endif

